/*******************************************************************************
 * Copyright (c) 2014 Bosch Software Innovations GmbH and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v1.0 which accompany this distribution.
 *
 * The Eclipse Public License is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * The Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 * Bosch Software Innovations GmbH - Please refer to git log
 *
 *******************************************************************************/
/*
 * generated by Xtext
 */
grammar InternalMapping;

options {
	superClass=AbstractInternalContentAssistParser;
}

@lexer::header {
package org.eclipse.vorto.editor.mapping.ide.contentassist.antlr.internal;

// Hack: Use our own Lexer superclass by means of import. 
// Currently there is no other way to specify the superclass for the lexer.
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.Lexer;
}

@parser::header {
package org.eclipse.vorto.editor.mapping.ide.contentassist.antlr.internal;

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.DFA;
import org.eclipse.vorto.editor.mapping.services.MappingGrammarAccess;

}
@parser::members {
	private MappingGrammarAccess grammarAccess;

	public void setGrammarAccess(MappingGrammarAccess grammarAccess) {
		this.grammarAccess = grammarAccess;
	}

	@Override
	protected Grammar getGrammar() {
		return grammarAccess.getGrammar();
	}

	@Override
	protected String getValueForTokenName(String tokenName) {
		return tokenName;
	}
}

// Entry rule entryRuleMappingModel
entryRuleMappingModel
:
{ before(grammarAccess.getMappingModelRule()); }
	 ruleMappingModel
{ after(grammarAccess.getMappingModelRule()); } 
	 EOF 
;

// Rule MappingModel
ruleMappingModel 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getMappingModelAccess().getAlternatives()); }
		(rule__MappingModel__Alternatives)
		{ after(grammarAccess.getMappingModelAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleDataTypeMappingModel
entryRuleDataTypeMappingModel
:
{ before(grammarAccess.getDataTypeMappingModelRule()); }
	 ruleDataTypeMappingModel
{ after(grammarAccess.getDataTypeMappingModelRule()); } 
	 EOF 
;

// Rule DataTypeMappingModel
ruleDataTypeMappingModel 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getDataTypeMappingModelAccess().getAlternatives()); }
		(rule__DataTypeMappingModel__Alternatives)
		{ after(grammarAccess.getDataTypeMappingModelAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleInfoModelMappingModel
entryRuleInfoModelMappingModel
:
{ before(grammarAccess.getInfoModelMappingModelRule()); }
	 ruleInfoModelMappingModel
{ after(grammarAccess.getInfoModelMappingModelRule()); } 
	 EOF 
;

// Rule InfoModelMappingModel
ruleInfoModelMappingModel 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getInfoModelMappingModelAccess().getGroup()); }
		(rule__InfoModelMappingModel__Group__0)
		{ after(grammarAccess.getInfoModelMappingModelAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleInfoModelMappingRule
entryRuleInfoModelMappingRule
:
{ before(grammarAccess.getInfoModelMappingRuleRule()); }
	 ruleInfoModelMappingRule
{ after(grammarAccess.getInfoModelMappingRuleRule()); } 
	 EOF 
;

// Rule InfoModelMappingRule
ruleInfoModelMappingRule 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getInfoModelMappingRuleAccess().getGroup()); }
		(rule__InfoModelMappingRule__Group__0)
		{ after(grammarAccess.getInfoModelMappingRuleAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleInfomodelSource
entryRuleInfomodelSource
:
{ before(grammarAccess.getInfomodelSourceRule()); }
	 ruleInfomodelSource
{ after(grammarAccess.getInfomodelSourceRule()); } 
	 EOF 
;

// Rule InfomodelSource
ruleInfomodelSource 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getInfomodelSourceAccess().getAlternatives()); }
		(rule__InfomodelSource__Alternatives)
		{ after(grammarAccess.getInfomodelSourceAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleInfoModelPropertySource
entryRuleInfoModelPropertySource
:
{ before(grammarAccess.getInfoModelPropertySourceRule()); }
	 ruleInfoModelPropertySource
{ after(grammarAccess.getInfoModelPropertySourceRule()); } 
	 EOF 
;

// Rule InfoModelPropertySource
ruleInfoModelPropertySource 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getInfoModelPropertySourceAccess().getGroup()); }
		(rule__InfoModelPropertySource__Group__0)
		{ after(grammarAccess.getInfoModelPropertySourceAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleInfoModelAttributeSource
entryRuleInfoModelAttributeSource
:
{ before(grammarAccess.getInfoModelAttributeSourceRule()); }
	 ruleInfoModelAttributeSource
{ after(grammarAccess.getInfoModelAttributeSourceRule()); } 
	 EOF 
;

// Rule InfoModelAttributeSource
ruleInfoModelAttributeSource 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getInfoModelAttributeSourceAccess().getGroup()); }
		(rule__InfoModelAttributeSource__Group__0)
		{ after(grammarAccess.getInfoModelAttributeSourceAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleFunctionBlockMappingModel
entryRuleFunctionBlockMappingModel
:
{ before(grammarAccess.getFunctionBlockMappingModelRule()); }
	 ruleFunctionBlockMappingModel
{ after(grammarAccess.getFunctionBlockMappingModelRule()); } 
	 EOF 
;

// Rule FunctionBlockMappingModel
ruleFunctionBlockMappingModel 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getFunctionBlockMappingModelAccess().getGroup()); }
		(rule__FunctionBlockMappingModel__Group__0)
		{ after(grammarAccess.getFunctionBlockMappingModelAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleModelReference
entryRuleModelReference
:
{ before(grammarAccess.getModelReferenceRule()); }
	 ruleModelReference
{ after(grammarAccess.getModelReferenceRule()); } 
	 EOF 
;

// Rule ModelReference
ruleModelReference 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getModelReferenceAccess().getGroup()); }
		(rule__ModelReference__Group__0)
		{ after(grammarAccess.getModelReferenceAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleFunctionBlockMappingRule
entryRuleFunctionBlockMappingRule
:
{ before(grammarAccess.getFunctionBlockMappingRuleRule()); }
	 ruleFunctionBlockMappingRule
{ after(grammarAccess.getFunctionBlockMappingRuleRule()); } 
	 EOF 
;

// Rule FunctionBlockMappingRule
ruleFunctionBlockMappingRule 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getFunctionBlockMappingRuleAccess().getGroup()); }
		(rule__FunctionBlockMappingRule__Group__0)
		{ after(grammarAccess.getFunctionBlockMappingRuleAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleFunctionBlockSource
entryRuleFunctionBlockSource
:
{ before(grammarAccess.getFunctionBlockSourceRule()); }
	 ruleFunctionBlockSource
{ after(grammarAccess.getFunctionBlockSourceRule()); } 
	 EOF 
;

// Rule FunctionBlockSource
ruleFunctionBlockSource 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getFunctionBlockSourceAccess().getAlternatives()); }
		(rule__FunctionBlockSource__Alternatives)
		{ after(grammarAccess.getFunctionBlockSourceAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleFunctionBlockPropertySource
entryRuleFunctionBlockPropertySource
:
{ before(grammarAccess.getFunctionBlockPropertySourceRule()); }
	 ruleFunctionBlockPropertySource
{ after(grammarAccess.getFunctionBlockPropertySourceRule()); } 
	 EOF 
;

// Rule FunctionBlockPropertySource
ruleFunctionBlockPropertySource 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getFunctionBlockPropertySourceAccess().getAlternatives()); }
		(rule__FunctionBlockPropertySource__Alternatives)
		{ after(grammarAccess.getFunctionBlockPropertySourceAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleFunctionBlockAttributeSource
entryRuleFunctionBlockAttributeSource
:
{ before(grammarAccess.getFunctionBlockAttributeSourceRule()); }
	 ruleFunctionBlockAttributeSource
{ after(grammarAccess.getFunctionBlockAttributeSourceRule()); } 
	 EOF 
;

// Rule FunctionBlockAttributeSource
ruleFunctionBlockAttributeSource 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getFunctionBlockAttributeSourceAccess().getGroup()); }
		(rule__FunctionBlockAttributeSource__Group__0)
		{ after(grammarAccess.getFunctionBlockAttributeSourceAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleConfigurationSource
entryRuleConfigurationSource
:
{ before(grammarAccess.getConfigurationSourceRule()); }
	 ruleConfigurationSource
{ after(grammarAccess.getConfigurationSourceRule()); } 
	 EOF 
;

// Rule ConfigurationSource
ruleConfigurationSource 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getConfigurationSourceAccess().getGroup()); }
		(rule__ConfigurationSource__Group__0)
		{ after(grammarAccess.getConfigurationSourceAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleStatusSource
entryRuleStatusSource
:
{ before(grammarAccess.getStatusSourceRule()); }
	 ruleStatusSource
{ after(grammarAccess.getStatusSourceRule()); } 
	 EOF 
;

// Rule StatusSource
ruleStatusSource 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getStatusSourceAccess().getGroup()); }
		(rule__StatusSource__Group__0)
		{ after(grammarAccess.getStatusSourceAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleFaultSource
entryRuleFaultSource
:
{ before(grammarAccess.getFaultSourceRule()); }
	 ruleFaultSource
{ after(grammarAccess.getFaultSourceRule()); } 
	 EOF 
;

// Rule FaultSource
ruleFaultSource 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getFaultSourceAccess().getGroup()); }
		(rule__FaultSource__Group__0)
		{ after(grammarAccess.getFaultSourceAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleOperationSource
entryRuleOperationSource
:
{ before(grammarAccess.getOperationSourceRule()); }
	 ruleOperationSource
{ after(grammarAccess.getOperationSourceRule()); } 
	 EOF 
;

// Rule OperationSource
ruleOperationSource 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getOperationSourceAccess().getGroup()); }
		(rule__OperationSource__Group__0)
		{ after(grammarAccess.getOperationSourceAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEventSource
entryRuleEventSource
:
{ before(grammarAccess.getEventSourceRule()); }
	 ruleEventSource
{ after(grammarAccess.getEventSourceRule()); } 
	 EOF 
;

// Rule EventSource
ruleEventSource 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEventSourceAccess().getGroup()); }
		(rule__EventSource__Group__0)
		{ after(grammarAccess.getEventSourceAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEntityMappingModel
entryRuleEntityMappingModel
:
{ before(grammarAccess.getEntityMappingModelRule()); }
	 ruleEntityMappingModel
{ after(grammarAccess.getEntityMappingModelRule()); } 
	 EOF 
;

// Rule EntityMappingModel
ruleEntityMappingModel 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEntityMappingModelAccess().getGroup()); }
		(rule__EntityMappingModel__Group__0)
		{ after(grammarAccess.getEntityMappingModelAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEntityMappingRule
entryRuleEntityMappingRule
:
{ before(grammarAccess.getEntityMappingRuleRule()); }
	 ruleEntityMappingRule
{ after(grammarAccess.getEntityMappingRuleRule()); } 
	 EOF 
;

// Rule EntityMappingRule
ruleEntityMappingRule 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEntityMappingRuleAccess().getGroup()); }
		(rule__EntityMappingRule__Group__0)
		{ after(grammarAccess.getEntityMappingRuleAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEntitySource
entryRuleEntitySource
:
{ before(grammarAccess.getEntitySourceRule()); }
	 ruleEntitySource
{ after(grammarAccess.getEntitySourceRule()); } 
	 EOF 
;

// Rule EntitySource
ruleEntitySource 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEntitySourceAccess().getAlternatives()); }
		(rule__EntitySource__Alternatives)
		{ after(grammarAccess.getEntitySourceAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEntityPropertySource
entryRuleEntityPropertySource
:
{ before(grammarAccess.getEntityPropertySourceRule()); }
	 ruleEntityPropertySource
{ after(grammarAccess.getEntityPropertySourceRule()); } 
	 EOF 
;

// Rule EntityPropertySource
ruleEntityPropertySource 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEntityPropertySourceAccess().getGroup()); }
		(rule__EntityPropertySource__Group__0)
		{ after(grammarAccess.getEntityPropertySourceAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEntityAttributeSource
entryRuleEntityAttributeSource
:
{ before(grammarAccess.getEntityAttributeSourceRule()); }
	 ruleEntityAttributeSource
{ after(grammarAccess.getEntityAttributeSourceRule()); } 
	 EOF 
;

// Rule EntityAttributeSource
ruleEntityAttributeSource 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEntityAttributeSourceAccess().getGroup()); }
		(rule__EntityAttributeSource__Group__0)
		{ after(grammarAccess.getEntityAttributeSourceAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEnumMappingModel
entryRuleEnumMappingModel
:
{ before(grammarAccess.getEnumMappingModelRule()); }
	 ruleEnumMappingModel
{ after(grammarAccess.getEnumMappingModelRule()); } 
	 EOF 
;

// Rule EnumMappingModel
ruleEnumMappingModel 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEnumMappingModelAccess().getGroup()); }
		(rule__EnumMappingModel__Group__0)
		{ after(grammarAccess.getEnumMappingModelAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEnumMappingRule
entryRuleEnumMappingRule
:
{ before(grammarAccess.getEnumMappingRuleRule()); }
	 ruleEnumMappingRule
{ after(grammarAccess.getEnumMappingRuleRule()); } 
	 EOF 
;

// Rule EnumMappingRule
ruleEnumMappingRule 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEnumMappingRuleAccess().getGroup()); }
		(rule__EnumMappingRule__Group__0)
		{ after(grammarAccess.getEnumMappingRuleAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEnumSource
entryRuleEnumSource
:
{ before(grammarAccess.getEnumSourceRule()); }
	 ruleEnumSource
{ after(grammarAccess.getEnumSourceRule()); } 
	 EOF 
;

// Rule EnumSource
ruleEnumSource 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEnumSourceAccess().getAlternatives()); }
		(rule__EnumSource__Alternatives)
		{ after(grammarAccess.getEnumSourceAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEnumPropertySource
entryRuleEnumPropertySource
:
{ before(grammarAccess.getEnumPropertySourceRule()); }
	 ruleEnumPropertySource
{ after(grammarAccess.getEnumPropertySourceRule()); } 
	 EOF 
;

// Rule EnumPropertySource
ruleEnumPropertySource 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEnumPropertySourceAccess().getGroup()); }
		(rule__EnumPropertySource__Group__0)
		{ after(grammarAccess.getEnumPropertySourceAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEnumAttributeSource
entryRuleEnumAttributeSource
:
{ before(grammarAccess.getEnumAttributeSourceRule()); }
	 ruleEnumAttributeSource
{ after(grammarAccess.getEnumAttributeSourceRule()); } 
	 EOF 
;

// Rule EnumAttributeSource
ruleEnumAttributeSource 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEnumAttributeSourceAccess().getGroup()); }
		(rule__EnumAttributeSource__Group__0)
		{ after(grammarAccess.getEnumAttributeSourceAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleTarget
entryRuleTarget
:
{ before(grammarAccess.getTargetRule()); }
	 ruleTarget
{ after(grammarAccess.getTargetRule()); } 
	 EOF 
;

// Rule Target
ruleTarget 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getTargetAccess().getAlternatives()); }
		(rule__Target__Alternatives)
		{ after(grammarAccess.getTargetAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleReferenceTarget
entryRuleReferenceTarget
:
{ before(grammarAccess.getReferenceTargetRule()); }
	 ruleReferenceTarget
{ after(grammarAccess.getReferenceTargetRule()); } 
	 EOF 
;

// Rule ReferenceTarget
ruleReferenceTarget 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getReferenceTargetAccess().getGroup()); }
		(rule__ReferenceTarget__Group__0)
		{ after(grammarAccess.getReferenceTargetAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleStereoTypeTarget
entryRuleStereoTypeTarget
:
{ before(grammarAccess.getStereoTypeTargetRule()); }
	 ruleStereoTypeTarget
{ after(grammarAccess.getStereoTypeTargetRule()); } 
	 EOF 
;

// Rule StereoTypeTarget
ruleStereoTypeTarget 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getStereoTypeTargetAccess().getGroup()); }
		(rule__StereoTypeTarget__Group__0)
		{ after(grammarAccess.getStereoTypeTargetAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleAttribute
entryRuleAttribute
:
{ before(grammarAccess.getAttributeRule()); }
	 ruleAttribute
{ after(grammarAccess.getAttributeRule()); } 
	 EOF 
;

// Rule Attribute
ruleAttribute 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getAttributeAccess().getGroup()); }
		(rule__Attribute__Group__0)
		{ after(grammarAccess.getAttributeAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleQualifiedName
entryRuleQualifiedName
:
{ before(grammarAccess.getQualifiedNameRule()); }
	 ruleQualifiedName
{ after(grammarAccess.getQualifiedNameRule()); } 
	 EOF 
;

// Rule QualifiedName
ruleQualifiedName 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getQualifiedNameAccess().getGroup()); }
		(rule__QualifiedName__Group__0)
		{ after(grammarAccess.getQualifiedNameAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleCATEGORY
entryRuleCATEGORY
:
{ before(grammarAccess.getCATEGORYRule()); }
	 ruleCATEGORY
{ after(grammarAccess.getCATEGORYRule()); } 
	 EOF 
;

// Rule CATEGORY
ruleCATEGORY 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getCATEGORYAccess().getGroup()); }
		(rule__CATEGORY__Group__0)
		{ after(grammarAccess.getCATEGORYAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Rule VortoLangVersion
ruleVortoLangVersion
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getVortoLangVersionAccess().getVersion1EnumLiteralDeclaration()); }
		('1.0')
		{ after(grammarAccess.getVortoLangVersionAccess().getVersion1EnumLiteralDeclaration()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Rule ModelAttribute
ruleModelAttribute
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getModelAttributeAccess().getAlternatives()); }
		(rule__ModelAttribute__Alternatives)
		{ after(grammarAccess.getModelAttributeAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__MappingModel__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMappingModelAccess().getInfoModelMappingModelParserRuleCall_0()); }
		ruleInfoModelMappingModel
		{ after(grammarAccess.getMappingModelAccess().getInfoModelMappingModelParserRuleCall_0()); }
	)
	|
	(
		{ before(grammarAccess.getMappingModelAccess().getFunctionBlockMappingModelParserRuleCall_1()); }
		ruleFunctionBlockMappingModel
		{ after(grammarAccess.getMappingModelAccess().getFunctionBlockMappingModelParserRuleCall_1()); }
	)
	|
	(
		{ before(grammarAccess.getMappingModelAccess().getDataTypeMappingModelParserRuleCall_2()); }
		ruleDataTypeMappingModel
		{ after(grammarAccess.getMappingModelAccess().getDataTypeMappingModelParserRuleCall_2()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__DataTypeMappingModel__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDataTypeMappingModelAccess().getEntityMappingModelParserRuleCall_0()); }
		ruleEntityMappingModel
		{ after(grammarAccess.getDataTypeMappingModelAccess().getEntityMappingModelParserRuleCall_0()); }
	)
	|
	(
		{ before(grammarAccess.getDataTypeMappingModelAccess().getEnumMappingModelParserRuleCall_1()); }
		ruleEnumMappingModel
		{ after(grammarAccess.getDataTypeMappingModelAccess().getEnumMappingModelParserRuleCall_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfomodelSource__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInfomodelSourceAccess().getInfoModelAttributeSourceParserRuleCall_0()); }
		ruleInfoModelAttributeSource
		{ after(grammarAccess.getInfomodelSourceAccess().getInfoModelAttributeSourceParserRuleCall_0()); }
	)
	|
	(
		{ before(grammarAccess.getInfomodelSourceAccess().getInfoModelPropertySourceParserRuleCall_1()); }
		ruleInfoModelPropertySource
		{ after(grammarAccess.getInfomodelSourceAccess().getInfoModelPropertySourceParserRuleCall_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockSource__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFunctionBlockSourceAccess().getFunctionBlockAttributeSourceParserRuleCall_0()); }
		ruleFunctionBlockAttributeSource
		{ after(grammarAccess.getFunctionBlockSourceAccess().getFunctionBlockAttributeSourceParserRuleCall_0()); }
	)
	|
	(
		{ before(grammarAccess.getFunctionBlockSourceAccess().getFunctionBlockPropertySourceParserRuleCall_1()); }
		ruleFunctionBlockPropertySource
		{ after(grammarAccess.getFunctionBlockSourceAccess().getFunctionBlockPropertySourceParserRuleCall_1()); }
	)
	|
	(
		{ before(grammarAccess.getFunctionBlockSourceAccess().getOperationSourceParserRuleCall_2()); }
		ruleOperationSource
		{ after(grammarAccess.getFunctionBlockSourceAccess().getOperationSourceParserRuleCall_2()); }
	)
	|
	(
		{ before(grammarAccess.getFunctionBlockSourceAccess().getEventSourceParserRuleCall_3()); }
		ruleEventSource
		{ after(grammarAccess.getFunctionBlockSourceAccess().getEventSourceParserRuleCall_3()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockPropertySource__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFunctionBlockPropertySourceAccess().getConfigurationSourceParserRuleCall_0()); }
		ruleConfigurationSource
		{ after(grammarAccess.getFunctionBlockPropertySourceAccess().getConfigurationSourceParserRuleCall_0()); }
	)
	|
	(
		{ before(grammarAccess.getFunctionBlockPropertySourceAccess().getStatusSourceParserRuleCall_1()); }
		ruleStatusSource
		{ after(grammarAccess.getFunctionBlockPropertySourceAccess().getStatusSourceParserRuleCall_1()); }
	)
	|
	(
		{ before(grammarAccess.getFunctionBlockPropertySourceAccess().getFaultSourceParserRuleCall_2()); }
		ruleFaultSource
		{ after(grammarAccess.getFunctionBlockPropertySourceAccess().getFaultSourceParserRuleCall_2()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntitySource__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntitySourceAccess().getEntityAttributeSourceParserRuleCall_0()); }
		ruleEntityAttributeSource
		{ after(grammarAccess.getEntitySourceAccess().getEntityAttributeSourceParserRuleCall_0()); }
	)
	|
	(
		{ before(grammarAccess.getEntitySourceAccess().getEntityPropertySourceParserRuleCall_1()); }
		ruleEntityPropertySource
		{ after(grammarAccess.getEntitySourceAccess().getEntityPropertySourceParserRuleCall_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumSource__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumSourceAccess().getEnumAttributeSourceParserRuleCall_0()); }
		ruleEnumAttributeSource
		{ after(grammarAccess.getEnumSourceAccess().getEnumAttributeSourceParserRuleCall_0()); }
	)
	|
	(
		{ before(grammarAccess.getEnumSourceAccess().getEnumPropertySourceParserRuleCall_1()); }
		ruleEnumPropertySource
		{ after(grammarAccess.getEnumSourceAccess().getEnumPropertySourceParserRuleCall_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Target__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getTargetAccess().getStereoTypeTargetParserRuleCall_0()); }
		ruleStereoTypeTarget
		{ after(grammarAccess.getTargetAccess().getStereoTypeTargetParserRuleCall_0()); }
	)
	|
	(
		{ before(grammarAccess.getTargetAccess().getReferenceTargetParserRuleCall_1()); }
		ruleReferenceTarget
		{ after(grammarAccess.getTargetAccess().getReferenceTargetParserRuleCall_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelAttribute__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getModelAttributeAccess().getNameEnumLiteralDeclaration_0()); }
		('name')
		{ after(grammarAccess.getModelAttributeAccess().getNameEnumLiteralDeclaration_0()); }
	)
	|
	(
		{ before(grammarAccess.getModelAttributeAccess().getNamespaceEnumLiteralDeclaration_1()); }
		('namespace')
		{ after(grammarAccess.getModelAttributeAccess().getNamespaceEnumLiteralDeclaration_1()); }
	)
	|
	(
		{ before(grammarAccess.getModelAttributeAccess().getVersionEnumLiteralDeclaration_2()); }
		('version')
		{ after(grammarAccess.getModelAttributeAccess().getVersionEnumLiteralDeclaration_2()); }
	)
	|
	(
		{ before(grammarAccess.getModelAttributeAccess().getDisplaynameEnumLiteralDeclaration_3()); }
		('displayname')
		{ after(grammarAccess.getModelAttributeAccess().getDisplaynameEnumLiteralDeclaration_3()); }
	)
	|
	(
		{ before(grammarAccess.getModelAttributeAccess().getCategoryEnumLiteralDeclaration_4()); }
		('category')
		{ after(grammarAccess.getModelAttributeAccess().getCategoryEnumLiteralDeclaration_4()); }
	)
	|
	(
		{ before(grammarAccess.getModelAttributeAccess().getDescriptionEnumLiteralDeclaration_5()); }
		('description')
		{ after(grammarAccess.getModelAttributeAccess().getDescriptionEnumLiteralDeclaration_5()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__Group__0__Impl
	rule__InfoModelMappingModel__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingModelAccess().getInfoModelMappingModelAction_0()); }
	()
	{ after(grammarAccess.getInfoModelMappingModelAccess().getInfoModelMappingModelAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__Group__1__Impl
	rule__InfoModelMappingModel__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingModelAccess().getVortolangKeyword_1()); }
	'vortolang'
	{ after(grammarAccess.getInfoModelMappingModelAccess().getVortolangKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__Group__2__Impl
	rule__InfoModelMappingModel__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingModelAccess().getLangAssignment_2()); }
	(rule__InfoModelMappingModel__LangAssignment_2)
	{ after(grammarAccess.getInfoModelMappingModelAccess().getLangAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__Group__3__Impl
	rule__InfoModelMappingModel__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingModelAccess().getNamespaceKeyword_3()); }
	'namespace'
	{ after(grammarAccess.getInfoModelMappingModelAccess().getNamespaceKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__Group__4__Impl
	rule__InfoModelMappingModel__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingModelAccess().getNamespaceAssignment_4()); }
	(rule__InfoModelMappingModel__NamespaceAssignment_4)
	{ after(grammarAccess.getInfoModelMappingModelAccess().getNamespaceAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__Group__5__Impl
	rule__InfoModelMappingModel__Group__6
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingModelAccess().getVersionKeyword_5()); }
	'version'
	{ after(grammarAccess.getInfoModelMappingModelAccess().getVersionKeyword_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__6
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__Group__6__Impl
	rule__InfoModelMappingModel__Group__7
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__6__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingModelAccess().getVersionAssignment_6()); }
	(rule__InfoModelMappingModel__VersionAssignment_6)
	{ after(grammarAccess.getInfoModelMappingModelAccess().getVersionAssignment_6()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__7
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__Group__7__Impl
	rule__InfoModelMappingModel__Group__8
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__7__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingModelAccess().getUnorderedGroup_7()); }
	(rule__InfoModelMappingModel__UnorderedGroup_7)
	{ after(grammarAccess.getInfoModelMappingModelAccess().getUnorderedGroup_7()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__8
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__Group__8__Impl
	rule__InfoModelMappingModel__Group__9
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__8__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingModelAccess().getReferencesAssignment_8()); }
	(rule__InfoModelMappingModel__ReferencesAssignment_8)*
	{ after(grammarAccess.getInfoModelMappingModelAccess().getReferencesAssignment_8()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__9
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__Group__9__Impl
	rule__InfoModelMappingModel__Group__10
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__9__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingModelAccess().getInfomodelmappingKeyword_9()); }
	'infomodelmapping'
	{ after(grammarAccess.getInfoModelMappingModelAccess().getInfomodelmappingKeyword_9()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__10
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__Group__10__Impl
	rule__InfoModelMappingModel__Group__11
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__10__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingModelAccess().getNameAssignment_10()); }
	(rule__InfoModelMappingModel__NameAssignment_10)
	{ after(grammarAccess.getInfoModelMappingModelAccess().getNameAssignment_10()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__11
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__Group__11__Impl
	rule__InfoModelMappingModel__Group__12
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__11__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingModelAccess().getLeftCurlyBracketKeyword_11()); }
	'{'
	{ after(grammarAccess.getInfoModelMappingModelAccess().getLeftCurlyBracketKeyword_11()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__12
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__Group__12__Impl
	rule__InfoModelMappingModel__Group__13
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__12__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingModelAccess().getTargetplatformKeyword_12()); }
	'targetplatform'
	{ after(grammarAccess.getInfoModelMappingModelAccess().getTargetplatformKeyword_12()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__13
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__Group__13__Impl
	rule__InfoModelMappingModel__Group__14
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__13__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingModelAccess().getTargetPlatformAssignment_13()); }
	(rule__InfoModelMappingModel__TargetPlatformAssignment_13)
	{ after(grammarAccess.getInfoModelMappingModelAccess().getTargetPlatformAssignment_13()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__14
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__Group__14__Impl
	rule__InfoModelMappingModel__Group__15
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__14__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingModelAccess().getRulesAssignment_14()); }
	(rule__InfoModelMappingModel__RulesAssignment_14)*
	{ after(grammarAccess.getInfoModelMappingModelAccess().getRulesAssignment_14()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__15
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__Group__15__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group__15__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingModelAccess().getRightCurlyBracketKeyword_15()); }
	'}'
	{ after(grammarAccess.getInfoModelMappingModelAccess().getRightCurlyBracketKeyword_15()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__InfoModelMappingModel__Group_7_0__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__Group_7_0__0__Impl
	rule__InfoModelMappingModel__Group_7_0__1
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group_7_0__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingModelAccess().getDisplaynameKeyword_7_0_0()); }
	'displayname'
	{ after(grammarAccess.getInfoModelMappingModelAccess().getDisplaynameKeyword_7_0_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group_7_0__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__Group_7_0__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group_7_0__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingModelAccess().getDisplaynameAssignment_7_0_1()); }
	(rule__InfoModelMappingModel__DisplaynameAssignment_7_0_1)
	{ after(grammarAccess.getInfoModelMappingModelAccess().getDisplaynameAssignment_7_0_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__InfoModelMappingModel__Group_7_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__Group_7_1__0__Impl
	rule__InfoModelMappingModel__Group_7_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group_7_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingModelAccess().getDescriptionKeyword_7_1_0()); }
	'description'
	{ after(grammarAccess.getInfoModelMappingModelAccess().getDescriptionKeyword_7_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group_7_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__Group_7_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group_7_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingModelAccess().getDescriptionAssignment_7_1_1()); }
	(rule__InfoModelMappingModel__DescriptionAssignment_7_1_1)
	{ after(grammarAccess.getInfoModelMappingModelAccess().getDescriptionAssignment_7_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__InfoModelMappingModel__Group_7_2__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__Group_7_2__0__Impl
	rule__InfoModelMappingModel__Group_7_2__1
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group_7_2__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingModelAccess().getCategoryKeyword_7_2_0()); }
	'category'
	{ after(grammarAccess.getInfoModelMappingModelAccess().getCategoryKeyword_7_2_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group_7_2__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__Group_7_2__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__Group_7_2__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingModelAccess().getCategoryAssignment_7_2_1()); }
	(rule__InfoModelMappingModel__CategoryAssignment_7_2_1)
	{ after(grammarAccess.getInfoModelMappingModelAccess().getCategoryAssignment_7_2_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__InfoModelMappingRule__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingRule__Group__0__Impl
	rule__InfoModelMappingRule__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingRule__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingRuleAccess().getFromKeyword_0()); }
	'from'
	{ after(grammarAccess.getInfoModelMappingRuleAccess().getFromKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingRule__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingRule__Group__1__Impl
	rule__InfoModelMappingRule__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingRule__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingRuleAccess().getSourcesAssignment_1()); }
	(rule__InfoModelMappingRule__SourcesAssignment_1)
	{ after(grammarAccess.getInfoModelMappingRuleAccess().getSourcesAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingRule__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingRule__Group__2__Impl
	rule__InfoModelMappingRule__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingRule__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingRuleAccess().getGroup_2()); }
	(rule__InfoModelMappingRule__Group_2__0)*
	{ after(grammarAccess.getInfoModelMappingRuleAccess().getGroup_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingRule__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingRule__Group__3__Impl
	rule__InfoModelMappingRule__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingRule__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingRuleAccess().getToKeyword_3()); }
	'to'
	{ after(grammarAccess.getInfoModelMappingRuleAccess().getToKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingRule__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingRule__Group__4__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingRule__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingRuleAccess().getTargetAssignment_4()); }
	(rule__InfoModelMappingRule__TargetAssignment_4)
	{ after(grammarAccess.getInfoModelMappingRuleAccess().getTargetAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__InfoModelMappingRule__Group_2__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingRule__Group_2__0__Impl
	rule__InfoModelMappingRule__Group_2__1
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingRule__Group_2__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingRuleAccess().getCommaKeyword_2_0()); }
	','
	{ after(grammarAccess.getInfoModelMappingRuleAccess().getCommaKeyword_2_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingRule__Group_2__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingRule__Group_2__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingRule__Group_2__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelMappingRuleAccess().getSourcesAssignment_2_1()); }
	(rule__InfoModelMappingRule__SourcesAssignment_2_1)
	{ after(grammarAccess.getInfoModelMappingRuleAccess().getSourcesAssignment_2_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__InfoModelPropertySource__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelPropertySource__Group__0__Impl
	rule__InfoModelPropertySource__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelPropertySource__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelPropertySourceAccess().getModelAssignment_0()); }
	(rule__InfoModelPropertySource__ModelAssignment_0)
	{ after(grammarAccess.getInfoModelPropertySourceAccess().getModelAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelPropertySource__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelPropertySource__Group__1__Impl
	rule__InfoModelPropertySource__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelPropertySource__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelPropertySourceAccess().getFullStopKeyword_1()); }
	'.'
	{ after(grammarAccess.getInfoModelPropertySourceAccess().getFullStopKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelPropertySource__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelPropertySource__Group__2__Impl
	rule__InfoModelPropertySource__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelPropertySource__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelPropertySourceAccess().getFunctionblocksKeyword_2()); }
	'functionblocks'
	{ after(grammarAccess.getInfoModelPropertySourceAccess().getFunctionblocksKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelPropertySource__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelPropertySource__Group__3__Impl
	rule__InfoModelPropertySource__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelPropertySource__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelPropertySourceAccess().getFullStopKeyword_3()); }
	'.'
	{ after(grammarAccess.getInfoModelPropertySourceAccess().getFullStopKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelPropertySource__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelPropertySource__Group__4__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelPropertySource__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelPropertySourceAccess().getPropertyAssignment_4()); }
	(rule__InfoModelPropertySource__PropertyAssignment_4)
	{ after(grammarAccess.getInfoModelPropertySourceAccess().getPropertyAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__InfoModelAttributeSource__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelAttributeSource__Group__0__Impl
	rule__InfoModelAttributeSource__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelAttributeSource__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelAttributeSourceAccess().getModelAssignment_0()); }
	(rule__InfoModelAttributeSource__ModelAssignment_0)
	{ after(grammarAccess.getInfoModelAttributeSourceAccess().getModelAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelAttributeSource__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelAttributeSource__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelAttributeSource__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelAttributeSourceAccess().getGroup_1()); }
	(rule__InfoModelAttributeSource__Group_1__0)?
	{ after(grammarAccess.getInfoModelAttributeSourceAccess().getGroup_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__InfoModelAttributeSource__Group_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelAttributeSource__Group_1__0__Impl
	rule__InfoModelAttributeSource__Group_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelAttributeSource__Group_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelAttributeSourceAccess().getFullStopKeyword_1_0()); }
	'.'
	{ after(grammarAccess.getInfoModelAttributeSourceAccess().getFullStopKeyword_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelAttributeSource__Group_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelAttributeSource__Group_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelAttributeSource__Group_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInfoModelAttributeSourceAccess().getAttributeAssignment_1_1()); }
	(rule__InfoModelAttributeSource__AttributeAssignment_1_1)
	{ after(grammarAccess.getInfoModelAttributeSourceAccess().getAttributeAssignment_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__FunctionBlockMappingModel__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__Group__0__Impl
	rule__FunctionBlockMappingModel__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingModelAccess().getFunctionBlockMappingModelAction_0()); }
	()
	{ after(grammarAccess.getFunctionBlockMappingModelAccess().getFunctionBlockMappingModelAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__Group__1__Impl
	rule__FunctionBlockMappingModel__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingModelAccess().getVortolangKeyword_1()); }
	'vortolang'
	{ after(grammarAccess.getFunctionBlockMappingModelAccess().getVortolangKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__Group__2__Impl
	rule__FunctionBlockMappingModel__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingModelAccess().getLangAssignment_2()); }
	(rule__FunctionBlockMappingModel__LangAssignment_2)
	{ after(grammarAccess.getFunctionBlockMappingModelAccess().getLangAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__Group__3__Impl
	rule__FunctionBlockMappingModel__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingModelAccess().getNamespaceKeyword_3()); }
	'namespace'
	{ after(grammarAccess.getFunctionBlockMappingModelAccess().getNamespaceKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__Group__4__Impl
	rule__FunctionBlockMappingModel__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingModelAccess().getNamespaceAssignment_4()); }
	(rule__FunctionBlockMappingModel__NamespaceAssignment_4)
	{ after(grammarAccess.getFunctionBlockMappingModelAccess().getNamespaceAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__Group__5__Impl
	rule__FunctionBlockMappingModel__Group__6
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingModelAccess().getVersionKeyword_5()); }
	'version'
	{ after(grammarAccess.getFunctionBlockMappingModelAccess().getVersionKeyword_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__6
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__Group__6__Impl
	rule__FunctionBlockMappingModel__Group__7
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__6__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingModelAccess().getVersionAssignment_6()); }
	(rule__FunctionBlockMappingModel__VersionAssignment_6)
	{ after(grammarAccess.getFunctionBlockMappingModelAccess().getVersionAssignment_6()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__7
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__Group__7__Impl
	rule__FunctionBlockMappingModel__Group__8
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__7__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingModelAccess().getUnorderedGroup_7()); }
	(rule__FunctionBlockMappingModel__UnorderedGroup_7)
	{ after(grammarAccess.getFunctionBlockMappingModelAccess().getUnorderedGroup_7()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__8
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__Group__8__Impl
	rule__FunctionBlockMappingModel__Group__9
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__8__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingModelAccess().getReferencesAssignment_8()); }
	(rule__FunctionBlockMappingModel__ReferencesAssignment_8)*
	{ after(grammarAccess.getFunctionBlockMappingModelAccess().getReferencesAssignment_8()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__9
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__Group__9__Impl
	rule__FunctionBlockMappingModel__Group__10
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__9__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingModelAccess().getFunctionblockmappingKeyword_9()); }
	'functionblockmapping'
	{ after(grammarAccess.getFunctionBlockMappingModelAccess().getFunctionblockmappingKeyword_9()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__10
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__Group__10__Impl
	rule__FunctionBlockMappingModel__Group__11
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__10__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingModelAccess().getNameAssignment_10()); }
	(rule__FunctionBlockMappingModel__NameAssignment_10)
	{ after(grammarAccess.getFunctionBlockMappingModelAccess().getNameAssignment_10()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__11
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__Group__11__Impl
	rule__FunctionBlockMappingModel__Group__12
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__11__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingModelAccess().getLeftCurlyBracketKeyword_11()); }
	'{'
	{ after(grammarAccess.getFunctionBlockMappingModelAccess().getLeftCurlyBracketKeyword_11()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__12
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__Group__12__Impl
	rule__FunctionBlockMappingModel__Group__13
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__12__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingModelAccess().getTargetplatformKeyword_12()); }
	'targetplatform'
	{ after(grammarAccess.getFunctionBlockMappingModelAccess().getTargetplatformKeyword_12()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__13
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__Group__13__Impl
	rule__FunctionBlockMappingModel__Group__14
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__13__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingModelAccess().getTargetPlatformAssignment_13()); }
	(rule__FunctionBlockMappingModel__TargetPlatformAssignment_13)
	{ after(grammarAccess.getFunctionBlockMappingModelAccess().getTargetPlatformAssignment_13()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__14
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__Group__14__Impl
	rule__FunctionBlockMappingModel__Group__15
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__14__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingModelAccess().getRulesAssignment_14()); }
	(rule__FunctionBlockMappingModel__RulesAssignment_14)*
	{ after(grammarAccess.getFunctionBlockMappingModelAccess().getRulesAssignment_14()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__15
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__Group__15__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group__15__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingModelAccess().getRightCurlyBracketKeyword_15()); }
	'}'
	{ after(grammarAccess.getFunctionBlockMappingModelAccess().getRightCurlyBracketKeyword_15()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__FunctionBlockMappingModel__Group_7_0__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__Group_7_0__0__Impl
	rule__FunctionBlockMappingModel__Group_7_0__1
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group_7_0__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingModelAccess().getDisplaynameKeyword_7_0_0()); }
	'displayname'
	{ after(grammarAccess.getFunctionBlockMappingModelAccess().getDisplaynameKeyword_7_0_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group_7_0__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__Group_7_0__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group_7_0__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingModelAccess().getDisplaynameAssignment_7_0_1()); }
	(rule__FunctionBlockMappingModel__DisplaynameAssignment_7_0_1)
	{ after(grammarAccess.getFunctionBlockMappingModelAccess().getDisplaynameAssignment_7_0_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__FunctionBlockMappingModel__Group_7_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__Group_7_1__0__Impl
	rule__FunctionBlockMappingModel__Group_7_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group_7_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingModelAccess().getDescriptionKeyword_7_1_0()); }
	'description'
	{ after(grammarAccess.getFunctionBlockMappingModelAccess().getDescriptionKeyword_7_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group_7_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__Group_7_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group_7_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingModelAccess().getDescriptionAssignment_7_1_1()); }
	(rule__FunctionBlockMappingModel__DescriptionAssignment_7_1_1)
	{ after(grammarAccess.getFunctionBlockMappingModelAccess().getDescriptionAssignment_7_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__FunctionBlockMappingModel__Group_7_2__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__Group_7_2__0__Impl
	rule__FunctionBlockMappingModel__Group_7_2__1
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group_7_2__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingModelAccess().getCategoryKeyword_7_2_0()); }
	'category'
	{ after(grammarAccess.getFunctionBlockMappingModelAccess().getCategoryKeyword_7_2_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group_7_2__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__Group_7_2__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__Group_7_2__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingModelAccess().getCategoryAssignment_7_2_1()); }
	(rule__FunctionBlockMappingModel__CategoryAssignment_7_2_1)
	{ after(grammarAccess.getFunctionBlockMappingModelAccess().getCategoryAssignment_7_2_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ModelReference__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ModelReference__Group__0__Impl
	rule__ModelReference__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getModelReferenceAccess().getUsingKeyword_0()); }
	'using'
	{ after(grammarAccess.getModelReferenceAccess().getUsingKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ModelReference__Group__1__Impl
	rule__ModelReference__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getModelReferenceAccess().getImportedNamespaceAssignment_1()); }
	(rule__ModelReference__ImportedNamespaceAssignment_1)
	{ after(grammarAccess.getModelReferenceAccess().getImportedNamespaceAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ModelReference__Group__2__Impl
	rule__ModelReference__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getModelReferenceAccess().getSemicolonKeyword_2()); }
	';'
	{ after(grammarAccess.getModelReferenceAccess().getSemicolonKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ModelReference__Group__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getModelReferenceAccess().getVersionAssignment_3()); }
	(rule__ModelReference__VersionAssignment_3)
	{ after(grammarAccess.getModelReferenceAccess().getVersionAssignment_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__FunctionBlockMappingRule__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingRule__Group__0__Impl
	rule__FunctionBlockMappingRule__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingRule__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingRuleAccess().getFromKeyword_0()); }
	'from'
	{ after(grammarAccess.getFunctionBlockMappingRuleAccess().getFromKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingRule__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingRule__Group__1__Impl
	rule__FunctionBlockMappingRule__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingRule__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingRuleAccess().getSourcesAssignment_1()); }
	(rule__FunctionBlockMappingRule__SourcesAssignment_1)
	{ after(grammarAccess.getFunctionBlockMappingRuleAccess().getSourcesAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingRule__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingRule__Group__2__Impl
	rule__FunctionBlockMappingRule__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingRule__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingRuleAccess().getGroup_2()); }
	(rule__FunctionBlockMappingRule__Group_2__0)*
	{ after(grammarAccess.getFunctionBlockMappingRuleAccess().getGroup_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingRule__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingRule__Group__3__Impl
	rule__FunctionBlockMappingRule__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingRule__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingRuleAccess().getToKeyword_3()); }
	'to'
	{ after(grammarAccess.getFunctionBlockMappingRuleAccess().getToKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingRule__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingRule__Group__4__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingRule__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingRuleAccess().getTargetAssignment_4()); }
	(rule__FunctionBlockMappingRule__TargetAssignment_4)
	{ after(grammarAccess.getFunctionBlockMappingRuleAccess().getTargetAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__FunctionBlockMappingRule__Group_2__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingRule__Group_2__0__Impl
	rule__FunctionBlockMappingRule__Group_2__1
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingRule__Group_2__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingRuleAccess().getCommaKeyword_2_0()); }
	','
	{ after(grammarAccess.getFunctionBlockMappingRuleAccess().getCommaKeyword_2_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingRule__Group_2__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingRule__Group_2__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingRule__Group_2__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockMappingRuleAccess().getSourcesAssignment_2_1()); }
	(rule__FunctionBlockMappingRule__SourcesAssignment_2_1)
	{ after(grammarAccess.getFunctionBlockMappingRuleAccess().getSourcesAssignment_2_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__FunctionBlockAttributeSource__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockAttributeSource__Group__0__Impl
	rule__FunctionBlockAttributeSource__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockAttributeSource__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockAttributeSourceAccess().getModelAssignment_0()); }
	(rule__FunctionBlockAttributeSource__ModelAssignment_0)
	{ after(grammarAccess.getFunctionBlockAttributeSourceAccess().getModelAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockAttributeSource__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockAttributeSource__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockAttributeSource__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockAttributeSourceAccess().getGroup_1()); }
	(rule__FunctionBlockAttributeSource__Group_1__0)?
	{ after(grammarAccess.getFunctionBlockAttributeSourceAccess().getGroup_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__FunctionBlockAttributeSource__Group_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockAttributeSource__Group_1__0__Impl
	rule__FunctionBlockAttributeSource__Group_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockAttributeSource__Group_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockAttributeSourceAccess().getFullStopKeyword_1_0()); }
	'.'
	{ after(grammarAccess.getFunctionBlockAttributeSourceAccess().getFullStopKeyword_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockAttributeSource__Group_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockAttributeSource__Group_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockAttributeSource__Group_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionBlockAttributeSourceAccess().getAttributeAssignment_1_1()); }
	(rule__FunctionBlockAttributeSource__AttributeAssignment_1_1)
	{ after(grammarAccess.getFunctionBlockAttributeSourceAccess().getAttributeAssignment_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ConfigurationSource__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ConfigurationSource__Group__0__Impl
	rule__ConfigurationSource__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ConfigurationSource__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getConfigurationSourceAccess().getModelAssignment_0()); }
	(rule__ConfigurationSource__ModelAssignment_0)
	{ after(grammarAccess.getConfigurationSourceAccess().getModelAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ConfigurationSource__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ConfigurationSource__Group__1__Impl
	rule__ConfigurationSource__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__ConfigurationSource__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getConfigurationSourceAccess().getFullStopKeyword_1()); }
	'.'
	{ after(grammarAccess.getConfigurationSourceAccess().getFullStopKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ConfigurationSource__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ConfigurationSource__Group__2__Impl
	rule__ConfigurationSource__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__ConfigurationSource__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getConfigurationSourceAccess().getConfigurationKeyword_2()); }
	'configuration'
	{ after(grammarAccess.getConfigurationSourceAccess().getConfigurationKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ConfigurationSource__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ConfigurationSource__Group__3__Impl
	rule__ConfigurationSource__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__ConfigurationSource__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getConfigurationSourceAccess().getFullStopKeyword_3()); }
	'.'
	{ after(grammarAccess.getConfigurationSourceAccess().getFullStopKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ConfigurationSource__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ConfigurationSource__Group__4__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ConfigurationSource__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getConfigurationSourceAccess().getPropertyAssignment_4()); }
	(rule__ConfigurationSource__PropertyAssignment_4)
	{ after(grammarAccess.getConfigurationSourceAccess().getPropertyAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__StatusSource__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__StatusSource__Group__0__Impl
	rule__StatusSource__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__StatusSource__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getStatusSourceAccess().getModelAssignment_0()); }
	(rule__StatusSource__ModelAssignment_0)
	{ after(grammarAccess.getStatusSourceAccess().getModelAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__StatusSource__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__StatusSource__Group__1__Impl
	rule__StatusSource__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__StatusSource__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getStatusSourceAccess().getFullStopKeyword_1()); }
	'.'
	{ after(grammarAccess.getStatusSourceAccess().getFullStopKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__StatusSource__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__StatusSource__Group__2__Impl
	rule__StatusSource__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__StatusSource__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getStatusSourceAccess().getStatusKeyword_2()); }
	'status'
	{ after(grammarAccess.getStatusSourceAccess().getStatusKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__StatusSource__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__StatusSource__Group__3__Impl
	rule__StatusSource__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__StatusSource__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getStatusSourceAccess().getFullStopKeyword_3()); }
	'.'
	{ after(grammarAccess.getStatusSourceAccess().getFullStopKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__StatusSource__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__StatusSource__Group__4__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__StatusSource__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getStatusSourceAccess().getPropertyAssignment_4()); }
	(rule__StatusSource__PropertyAssignment_4)
	{ after(grammarAccess.getStatusSourceAccess().getPropertyAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__FaultSource__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FaultSource__Group__0__Impl
	rule__FaultSource__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__FaultSource__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFaultSourceAccess().getModelAssignment_0()); }
	(rule__FaultSource__ModelAssignment_0)
	{ after(grammarAccess.getFaultSourceAccess().getModelAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FaultSource__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FaultSource__Group__1__Impl
	rule__FaultSource__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__FaultSource__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFaultSourceAccess().getFullStopKeyword_1()); }
	'.'
	{ after(grammarAccess.getFaultSourceAccess().getFullStopKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FaultSource__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FaultSource__Group__2__Impl
	rule__FaultSource__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__FaultSource__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFaultSourceAccess().getFaultKeyword_2()); }
	'fault'
	{ after(grammarAccess.getFaultSourceAccess().getFaultKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FaultSource__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FaultSource__Group__3__Impl
	rule__FaultSource__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__FaultSource__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFaultSourceAccess().getFullStopKeyword_3()); }
	'.'
	{ after(grammarAccess.getFaultSourceAccess().getFullStopKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FaultSource__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FaultSource__Group__4__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__FaultSource__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFaultSourceAccess().getPropertyAssignment_4()); }
	(rule__FaultSource__PropertyAssignment_4)
	{ after(grammarAccess.getFaultSourceAccess().getPropertyAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__OperationSource__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__OperationSource__Group__0__Impl
	rule__OperationSource__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__OperationSource__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getOperationSourceAccess().getModelAssignment_0()); }
	(rule__OperationSource__ModelAssignment_0)
	{ after(grammarAccess.getOperationSourceAccess().getModelAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__OperationSource__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__OperationSource__Group__1__Impl
	rule__OperationSource__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__OperationSource__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getOperationSourceAccess().getFullStopKeyword_1()); }
	'.'
	{ after(grammarAccess.getOperationSourceAccess().getFullStopKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__OperationSource__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__OperationSource__Group__2__Impl
	rule__OperationSource__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__OperationSource__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getOperationSourceAccess().getOperationKeyword_2()); }
	'operation'
	{ after(grammarAccess.getOperationSourceAccess().getOperationKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__OperationSource__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__OperationSource__Group__3__Impl
	rule__OperationSource__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__OperationSource__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getOperationSourceAccess().getFullStopKeyword_3()); }
	'.'
	{ after(grammarAccess.getOperationSourceAccess().getFullStopKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__OperationSource__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__OperationSource__Group__4__Impl
	rule__OperationSource__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__OperationSource__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getOperationSourceAccess().getOperationAssignment_4()); }
	(rule__OperationSource__OperationAssignment_4)
	{ after(grammarAccess.getOperationSourceAccess().getOperationAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__OperationSource__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__OperationSource__Group__5__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__OperationSource__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getOperationSourceAccess().getGroup_5()); }
	(rule__OperationSource__Group_5__0)?
	{ after(grammarAccess.getOperationSourceAccess().getGroup_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__OperationSource__Group_5__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__OperationSource__Group_5__0__Impl
	rule__OperationSource__Group_5__1
;
finally {
	restoreStackSize(stackSize);
}

rule__OperationSource__Group_5__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getOperationSourceAccess().getFullStopKeyword_5_0()); }
	'.'
	{ after(grammarAccess.getOperationSourceAccess().getFullStopKeyword_5_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__OperationSource__Group_5__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__OperationSource__Group_5__1__Impl
	rule__OperationSource__Group_5__2
;
finally {
	restoreStackSize(stackSize);
}

rule__OperationSource__Group_5__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getOperationSourceAccess().getParamsKeyword_5_1()); }
	'params'
	{ after(grammarAccess.getOperationSourceAccess().getParamsKeyword_5_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__OperationSource__Group_5__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__OperationSource__Group_5__2__Impl
	rule__OperationSource__Group_5__3
;
finally {
	restoreStackSize(stackSize);
}

rule__OperationSource__Group_5__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	(
		{ before(grammarAccess.getOperationSourceAccess().getFullStopKeyword_5_2()); }
		('.')
		{ after(grammarAccess.getOperationSourceAccess().getFullStopKeyword_5_2()); }
	)
	(
		{ before(grammarAccess.getOperationSourceAccess().getFullStopKeyword_5_2()); }
		('.')*
		{ after(grammarAccess.getOperationSourceAccess().getFullStopKeyword_5_2()); }
	)
)
;
finally {
	restoreStackSize(stackSize);
}

rule__OperationSource__Group_5__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__OperationSource__Group_5__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__OperationSource__Group_5__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getOperationSourceAccess().getParamAssignment_5_3()); }
	(rule__OperationSource__ParamAssignment_5_3)
	{ after(grammarAccess.getOperationSourceAccess().getParamAssignment_5_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EventSource__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EventSource__Group__0__Impl
	rule__EventSource__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EventSource__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEventSourceAccess().getModelAssignment_0()); }
	(rule__EventSource__ModelAssignment_0)
	{ after(grammarAccess.getEventSourceAccess().getModelAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EventSource__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EventSource__Group__1__Impl
	rule__EventSource__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__EventSource__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEventSourceAccess().getFullStopKeyword_1()); }
	'.'
	{ after(grammarAccess.getEventSourceAccess().getFullStopKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EventSource__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EventSource__Group__2__Impl
	rule__EventSource__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__EventSource__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEventSourceAccess().getEventKeyword_2()); }
	'event'
	{ after(grammarAccess.getEventSourceAccess().getEventKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EventSource__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EventSource__Group__3__Impl
	rule__EventSource__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__EventSource__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEventSourceAccess().getFullStopKeyword_3()); }
	'.'
	{ after(grammarAccess.getEventSourceAccess().getFullStopKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EventSource__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EventSource__Group__4__Impl
	rule__EventSource__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__EventSource__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEventSourceAccess().getEventAssignment_4()); }
	(rule__EventSource__EventAssignment_4)
	{ after(grammarAccess.getEventSourceAccess().getEventAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EventSource__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EventSource__Group__5__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EventSource__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEventSourceAccess().getGroup_5()); }
	(rule__EventSource__Group_5__0)?
	{ after(grammarAccess.getEventSourceAccess().getGroup_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EventSource__Group_5__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EventSource__Group_5__0__Impl
	rule__EventSource__Group_5__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EventSource__Group_5__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEventSourceAccess().getFullStopKeyword_5_0()); }
	'.'
	{ after(grammarAccess.getEventSourceAccess().getFullStopKeyword_5_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EventSource__Group_5__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EventSource__Group_5__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EventSource__Group_5__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEventSourceAccess().getEventPropertyAssignment_5_1()); }
	(rule__EventSource__EventPropertyAssignment_5_1)
	{ after(grammarAccess.getEventSourceAccess().getEventPropertyAssignment_5_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EntityMappingModel__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__Group__0__Impl
	rule__EntityMappingModel__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingModelAccess().getEntityMappingModelAction_0()); }
	()
	{ after(grammarAccess.getEntityMappingModelAccess().getEntityMappingModelAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__Group__1__Impl
	rule__EntityMappingModel__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingModelAccess().getVortolangKeyword_1()); }
	'vortolang'
	{ after(grammarAccess.getEntityMappingModelAccess().getVortolangKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__Group__2__Impl
	rule__EntityMappingModel__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingModelAccess().getLangAssignment_2()); }
	(rule__EntityMappingModel__LangAssignment_2)
	{ after(grammarAccess.getEntityMappingModelAccess().getLangAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__Group__3__Impl
	rule__EntityMappingModel__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingModelAccess().getNamespaceKeyword_3()); }
	'namespace'
	{ after(grammarAccess.getEntityMappingModelAccess().getNamespaceKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__Group__4__Impl
	rule__EntityMappingModel__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingModelAccess().getNamespaceAssignment_4()); }
	(rule__EntityMappingModel__NamespaceAssignment_4)
	{ after(grammarAccess.getEntityMappingModelAccess().getNamespaceAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__Group__5__Impl
	rule__EntityMappingModel__Group__6
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingModelAccess().getVersionKeyword_5()); }
	'version'
	{ after(grammarAccess.getEntityMappingModelAccess().getVersionKeyword_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__6
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__Group__6__Impl
	rule__EntityMappingModel__Group__7
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__6__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingModelAccess().getVersionAssignment_6()); }
	(rule__EntityMappingModel__VersionAssignment_6)
	{ after(grammarAccess.getEntityMappingModelAccess().getVersionAssignment_6()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__7
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__Group__7__Impl
	rule__EntityMappingModel__Group__8
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__7__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingModelAccess().getUnorderedGroup_7()); }
	(rule__EntityMappingModel__UnorderedGroup_7)
	{ after(grammarAccess.getEntityMappingModelAccess().getUnorderedGroup_7()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__8
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__Group__8__Impl
	rule__EntityMappingModel__Group__9
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__8__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingModelAccess().getReferencesAssignment_8()); }
	(rule__EntityMappingModel__ReferencesAssignment_8)*
	{ after(grammarAccess.getEntityMappingModelAccess().getReferencesAssignment_8()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__9
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__Group__9__Impl
	rule__EntityMappingModel__Group__10
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__9__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingModelAccess().getEntitymappingKeyword_9()); }
	'entitymapping'
	{ after(grammarAccess.getEntityMappingModelAccess().getEntitymappingKeyword_9()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__10
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__Group__10__Impl
	rule__EntityMappingModel__Group__11
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__10__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingModelAccess().getNameAssignment_10()); }
	(rule__EntityMappingModel__NameAssignment_10)
	{ after(grammarAccess.getEntityMappingModelAccess().getNameAssignment_10()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__11
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__Group__11__Impl
	rule__EntityMappingModel__Group__12
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__11__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingModelAccess().getLeftCurlyBracketKeyword_11()); }
	'{'
	{ after(grammarAccess.getEntityMappingModelAccess().getLeftCurlyBracketKeyword_11()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__12
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__Group__12__Impl
	rule__EntityMappingModel__Group__13
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__12__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingModelAccess().getTargetplatformKeyword_12()); }
	'targetplatform'
	{ after(grammarAccess.getEntityMappingModelAccess().getTargetplatformKeyword_12()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__13
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__Group__13__Impl
	rule__EntityMappingModel__Group__14
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__13__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingModelAccess().getTargetPlatformAssignment_13()); }
	(rule__EntityMappingModel__TargetPlatformAssignment_13)
	{ after(grammarAccess.getEntityMappingModelAccess().getTargetPlatformAssignment_13()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__14
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__Group__14__Impl
	rule__EntityMappingModel__Group__15
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__14__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingModelAccess().getRulesAssignment_14()); }
	(rule__EntityMappingModel__RulesAssignment_14)*
	{ after(grammarAccess.getEntityMappingModelAccess().getRulesAssignment_14()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__15
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__Group__15__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group__15__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingModelAccess().getRightCurlyBracketKeyword_15()); }
	'}'
	{ after(grammarAccess.getEntityMappingModelAccess().getRightCurlyBracketKeyword_15()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EntityMappingModel__Group_7_0__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__Group_7_0__0__Impl
	rule__EntityMappingModel__Group_7_0__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group_7_0__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingModelAccess().getDisplaynameKeyword_7_0_0()); }
	'displayname'
	{ after(grammarAccess.getEntityMappingModelAccess().getDisplaynameKeyword_7_0_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group_7_0__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__Group_7_0__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group_7_0__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingModelAccess().getDisplaynameAssignment_7_0_1()); }
	(rule__EntityMappingModel__DisplaynameAssignment_7_0_1)
	{ after(grammarAccess.getEntityMappingModelAccess().getDisplaynameAssignment_7_0_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EntityMappingModel__Group_7_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__Group_7_1__0__Impl
	rule__EntityMappingModel__Group_7_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group_7_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingModelAccess().getDescriptionKeyword_7_1_0()); }
	'description'
	{ after(grammarAccess.getEntityMappingModelAccess().getDescriptionKeyword_7_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group_7_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__Group_7_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group_7_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingModelAccess().getDescriptionAssignment_7_1_1()); }
	(rule__EntityMappingModel__DescriptionAssignment_7_1_1)
	{ after(grammarAccess.getEntityMappingModelAccess().getDescriptionAssignment_7_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EntityMappingModel__Group_7_2__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__Group_7_2__0__Impl
	rule__EntityMappingModel__Group_7_2__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group_7_2__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingModelAccess().getCategoryKeyword_7_2_0()); }
	'category'
	{ after(grammarAccess.getEntityMappingModelAccess().getCategoryKeyword_7_2_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group_7_2__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__Group_7_2__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__Group_7_2__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingModelAccess().getCategoryAssignment_7_2_1()); }
	(rule__EntityMappingModel__CategoryAssignment_7_2_1)
	{ after(grammarAccess.getEntityMappingModelAccess().getCategoryAssignment_7_2_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EntityMappingRule__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingRule__Group__0__Impl
	rule__EntityMappingRule__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingRule__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingRuleAccess().getFromKeyword_0()); }
	'from'
	{ after(grammarAccess.getEntityMappingRuleAccess().getFromKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingRule__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingRule__Group__1__Impl
	rule__EntityMappingRule__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingRule__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingRuleAccess().getSourcesAssignment_1()); }
	(rule__EntityMappingRule__SourcesAssignment_1)
	{ after(grammarAccess.getEntityMappingRuleAccess().getSourcesAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingRule__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingRule__Group__2__Impl
	rule__EntityMappingRule__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingRule__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingRuleAccess().getGroup_2()); }
	(rule__EntityMappingRule__Group_2__0)*
	{ after(grammarAccess.getEntityMappingRuleAccess().getGroup_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingRule__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingRule__Group__3__Impl
	rule__EntityMappingRule__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingRule__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingRuleAccess().getToKeyword_3()); }
	'to'
	{ after(grammarAccess.getEntityMappingRuleAccess().getToKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingRule__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingRule__Group__4__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingRule__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingRuleAccess().getTargetAssignment_4()); }
	(rule__EntityMappingRule__TargetAssignment_4)
	{ after(grammarAccess.getEntityMappingRuleAccess().getTargetAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EntityMappingRule__Group_2__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingRule__Group_2__0__Impl
	rule__EntityMappingRule__Group_2__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingRule__Group_2__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingRuleAccess().getCommaKeyword_2_0()); }
	','
	{ after(grammarAccess.getEntityMappingRuleAccess().getCommaKeyword_2_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingRule__Group_2__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingRule__Group_2__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingRule__Group_2__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityMappingRuleAccess().getSourcesAssignment_2_1()); }
	(rule__EntityMappingRule__SourcesAssignment_2_1)
	{ after(grammarAccess.getEntityMappingRuleAccess().getSourcesAssignment_2_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EntityPropertySource__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityPropertySource__Group__0__Impl
	rule__EntityPropertySource__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityPropertySource__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityPropertySourceAccess().getModelAssignment_0()); }
	(rule__EntityPropertySource__ModelAssignment_0)
	{ after(grammarAccess.getEntityPropertySourceAccess().getModelAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityPropertySource__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityPropertySource__Group__1__Impl
	rule__EntityPropertySource__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityPropertySource__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityPropertySourceAccess().getFullStopKeyword_1()); }
	'.'
	{ after(grammarAccess.getEntityPropertySourceAccess().getFullStopKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityPropertySource__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityPropertySource__Group__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityPropertySource__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityPropertySourceAccess().getPropertyAssignment_2()); }
	(rule__EntityPropertySource__PropertyAssignment_2)
	{ after(grammarAccess.getEntityPropertySourceAccess().getPropertyAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EntityAttributeSource__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityAttributeSource__Group__0__Impl
	rule__EntityAttributeSource__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityAttributeSource__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAttributeSourceAccess().getModelAssignment_0()); }
	(rule__EntityAttributeSource__ModelAssignment_0)
	{ after(grammarAccess.getEntityAttributeSourceAccess().getModelAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityAttributeSource__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityAttributeSource__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityAttributeSource__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAttributeSourceAccess().getGroup_1()); }
	(rule__EntityAttributeSource__Group_1__0)?
	{ after(grammarAccess.getEntityAttributeSourceAccess().getGroup_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EntityAttributeSource__Group_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityAttributeSource__Group_1__0__Impl
	rule__EntityAttributeSource__Group_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityAttributeSource__Group_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAttributeSourceAccess().getFullStopKeyword_1_0()); }
	'.'
	{ after(grammarAccess.getEntityAttributeSourceAccess().getFullStopKeyword_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityAttributeSource__Group_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityAttributeSource__Group_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityAttributeSource__Group_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEntityAttributeSourceAccess().getAttributeAssignment_1_1()); }
	(rule__EntityAttributeSource__AttributeAssignment_1_1)
	{ after(grammarAccess.getEntityAttributeSourceAccess().getAttributeAssignment_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EnumMappingModel__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__Group__0__Impl
	rule__EnumMappingModel__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingModelAccess().getEnumMappingModelAction_0()); }
	()
	{ after(grammarAccess.getEnumMappingModelAccess().getEnumMappingModelAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__Group__1__Impl
	rule__EnumMappingModel__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingModelAccess().getVortolangKeyword_1()); }
	'vortolang'
	{ after(grammarAccess.getEnumMappingModelAccess().getVortolangKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__Group__2__Impl
	rule__EnumMappingModel__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingModelAccess().getLangAssignment_2()); }
	(rule__EnumMappingModel__LangAssignment_2)
	{ after(grammarAccess.getEnumMappingModelAccess().getLangAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__Group__3__Impl
	rule__EnumMappingModel__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingModelAccess().getNamespaceKeyword_3()); }
	'namespace'
	{ after(grammarAccess.getEnumMappingModelAccess().getNamespaceKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__Group__4__Impl
	rule__EnumMappingModel__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingModelAccess().getNamespaceAssignment_4()); }
	(rule__EnumMappingModel__NamespaceAssignment_4)
	{ after(grammarAccess.getEnumMappingModelAccess().getNamespaceAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__Group__5__Impl
	rule__EnumMappingModel__Group__6
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingModelAccess().getVersionKeyword_5()); }
	'version'
	{ after(grammarAccess.getEnumMappingModelAccess().getVersionKeyword_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__6
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__Group__6__Impl
	rule__EnumMappingModel__Group__7
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__6__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingModelAccess().getVersionAssignment_6()); }
	(rule__EnumMappingModel__VersionAssignment_6)
	{ after(grammarAccess.getEnumMappingModelAccess().getVersionAssignment_6()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__7
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__Group__7__Impl
	rule__EnumMappingModel__Group__8
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__7__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingModelAccess().getUnorderedGroup_7()); }
	(rule__EnumMappingModel__UnorderedGroup_7)
	{ after(grammarAccess.getEnumMappingModelAccess().getUnorderedGroup_7()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__8
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__Group__8__Impl
	rule__EnumMappingModel__Group__9
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__8__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingModelAccess().getReferencesAssignment_8()); }
	(rule__EnumMappingModel__ReferencesAssignment_8)*
	{ after(grammarAccess.getEnumMappingModelAccess().getReferencesAssignment_8()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__9
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__Group__9__Impl
	rule__EnumMappingModel__Group__10
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__9__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingModelAccess().getEnummappingKeyword_9()); }
	'enummapping'
	{ after(grammarAccess.getEnumMappingModelAccess().getEnummappingKeyword_9()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__10
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__Group__10__Impl
	rule__EnumMappingModel__Group__11
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__10__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingModelAccess().getNameAssignment_10()); }
	(rule__EnumMappingModel__NameAssignment_10)
	{ after(grammarAccess.getEnumMappingModelAccess().getNameAssignment_10()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__11
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__Group__11__Impl
	rule__EnumMappingModel__Group__12
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__11__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingModelAccess().getLeftCurlyBracketKeyword_11()); }
	'{'
	{ after(grammarAccess.getEnumMappingModelAccess().getLeftCurlyBracketKeyword_11()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__12
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__Group__12__Impl
	rule__EnumMappingModel__Group__13
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__12__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingModelAccess().getTargetplatformKeyword_12()); }
	'targetplatform'
	{ after(grammarAccess.getEnumMappingModelAccess().getTargetplatformKeyword_12()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__13
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__Group__13__Impl
	rule__EnumMappingModel__Group__14
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__13__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingModelAccess().getTargetPlatformAssignment_13()); }
	(rule__EnumMappingModel__TargetPlatformAssignment_13)
	{ after(grammarAccess.getEnumMappingModelAccess().getTargetPlatformAssignment_13()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__14
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__Group__14__Impl
	rule__EnumMappingModel__Group__15
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__14__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingModelAccess().getRulesAssignment_14()); }
	(rule__EnumMappingModel__RulesAssignment_14)*
	{ after(grammarAccess.getEnumMappingModelAccess().getRulesAssignment_14()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__15
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__Group__15__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group__15__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingModelAccess().getRightCurlyBracketKeyword_15()); }
	'}'
	{ after(grammarAccess.getEnumMappingModelAccess().getRightCurlyBracketKeyword_15()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EnumMappingModel__Group_7_0__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__Group_7_0__0__Impl
	rule__EnumMappingModel__Group_7_0__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group_7_0__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingModelAccess().getDisplaynameKeyword_7_0_0()); }
	'displayname'
	{ after(grammarAccess.getEnumMappingModelAccess().getDisplaynameKeyword_7_0_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group_7_0__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__Group_7_0__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group_7_0__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingModelAccess().getDisplaynameAssignment_7_0_1()); }
	(rule__EnumMappingModel__DisplaynameAssignment_7_0_1)
	{ after(grammarAccess.getEnumMappingModelAccess().getDisplaynameAssignment_7_0_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EnumMappingModel__Group_7_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__Group_7_1__0__Impl
	rule__EnumMappingModel__Group_7_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group_7_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingModelAccess().getDescriptionKeyword_7_1_0()); }
	'description'
	{ after(grammarAccess.getEnumMappingModelAccess().getDescriptionKeyword_7_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group_7_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__Group_7_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group_7_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingModelAccess().getDescriptionAssignment_7_1_1()); }
	(rule__EnumMappingModel__DescriptionAssignment_7_1_1)
	{ after(grammarAccess.getEnumMappingModelAccess().getDescriptionAssignment_7_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EnumMappingModel__Group_7_2__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__Group_7_2__0__Impl
	rule__EnumMappingModel__Group_7_2__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group_7_2__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingModelAccess().getCategoryKeyword_7_2_0()); }
	'category'
	{ after(grammarAccess.getEnumMappingModelAccess().getCategoryKeyword_7_2_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group_7_2__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__Group_7_2__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__Group_7_2__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingModelAccess().getCategoryAssignment_7_2_1()); }
	(rule__EnumMappingModel__CategoryAssignment_7_2_1)
	{ after(grammarAccess.getEnumMappingModelAccess().getCategoryAssignment_7_2_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EnumMappingRule__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingRule__Group__0__Impl
	rule__EnumMappingRule__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingRule__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingRuleAccess().getFromKeyword_0()); }
	'from'
	{ after(grammarAccess.getEnumMappingRuleAccess().getFromKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingRule__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingRule__Group__1__Impl
	rule__EnumMappingRule__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingRule__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingRuleAccess().getSourcesAssignment_1()); }
	(rule__EnumMappingRule__SourcesAssignment_1)
	{ after(grammarAccess.getEnumMappingRuleAccess().getSourcesAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingRule__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingRule__Group__2__Impl
	rule__EnumMappingRule__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingRule__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingRuleAccess().getGroup_2()); }
	(rule__EnumMappingRule__Group_2__0)*
	{ after(grammarAccess.getEnumMappingRuleAccess().getGroup_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingRule__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingRule__Group__3__Impl
	rule__EnumMappingRule__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingRule__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingRuleAccess().getToKeyword_3()); }
	'to'
	{ after(grammarAccess.getEnumMappingRuleAccess().getToKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingRule__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingRule__Group__4__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingRule__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingRuleAccess().getTargetAssignment_4()); }
	(rule__EnumMappingRule__TargetAssignment_4)
	{ after(grammarAccess.getEnumMappingRuleAccess().getTargetAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EnumMappingRule__Group_2__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingRule__Group_2__0__Impl
	rule__EnumMappingRule__Group_2__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingRule__Group_2__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingRuleAccess().getCommaKeyword_2_0()); }
	','
	{ after(grammarAccess.getEnumMappingRuleAccess().getCommaKeyword_2_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingRule__Group_2__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingRule__Group_2__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingRule__Group_2__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumMappingRuleAccess().getSourcesAssignment_2_1()); }
	(rule__EnumMappingRule__SourcesAssignment_2_1)
	{ after(grammarAccess.getEnumMappingRuleAccess().getSourcesAssignment_2_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EnumPropertySource__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumPropertySource__Group__0__Impl
	rule__EnumPropertySource__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumPropertySource__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumPropertySourceAccess().getModelAssignment_0()); }
	(rule__EnumPropertySource__ModelAssignment_0)
	{ after(grammarAccess.getEnumPropertySourceAccess().getModelAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumPropertySource__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumPropertySource__Group__1__Impl
	rule__EnumPropertySource__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumPropertySource__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumPropertySourceAccess().getFullStopKeyword_1()); }
	'.'
	{ after(grammarAccess.getEnumPropertySourceAccess().getFullStopKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumPropertySource__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumPropertySource__Group__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumPropertySource__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumPropertySourceAccess().getPropertyAssignment_2()); }
	(rule__EnumPropertySource__PropertyAssignment_2)
	{ after(grammarAccess.getEnumPropertySourceAccess().getPropertyAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EnumAttributeSource__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumAttributeSource__Group__0__Impl
	rule__EnumAttributeSource__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumAttributeSource__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAttributeSourceAccess().getModelAssignment_0()); }
	(rule__EnumAttributeSource__ModelAssignment_0)
	{ after(grammarAccess.getEnumAttributeSourceAccess().getModelAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumAttributeSource__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumAttributeSource__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumAttributeSource__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAttributeSourceAccess().getGroup_1()); }
	(rule__EnumAttributeSource__Group_1__0)?
	{ after(grammarAccess.getEnumAttributeSourceAccess().getGroup_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EnumAttributeSource__Group_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumAttributeSource__Group_1__0__Impl
	rule__EnumAttributeSource__Group_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumAttributeSource__Group_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAttributeSourceAccess().getFullStopKeyword_1_0()); }
	'.'
	{ after(grammarAccess.getEnumAttributeSourceAccess().getFullStopKeyword_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumAttributeSource__Group_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumAttributeSource__Group_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumAttributeSource__Group_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEnumAttributeSourceAccess().getAttributeAssignment_1_1()); }
	(rule__EnumAttributeSource__AttributeAssignment_1_1)
	{ after(grammarAccess.getEnumAttributeSourceAccess().getAttributeAssignment_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ReferenceTarget__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ReferenceTarget__Group__0__Impl
	rule__ReferenceTarget__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ReferenceTarget__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getReferenceTargetAccess().getReferenceKeyword_0()); }
	'reference'
	{ after(grammarAccess.getReferenceTargetAccess().getReferenceKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ReferenceTarget__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ReferenceTarget__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ReferenceTarget__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getReferenceTargetAccess().getMappingModelAssignment_1()); }
	(rule__ReferenceTarget__MappingModelAssignment_1)
	{ after(grammarAccess.getReferenceTargetAccess().getMappingModelAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__StereoTypeTarget__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__StereoTypeTarget__Group__0__Impl
	rule__StereoTypeTarget__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__StereoTypeTarget__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getStereoTypeTargetAccess().getNameAssignment_0()); }
	(rule__StereoTypeTarget__NameAssignment_0)
	{ after(grammarAccess.getStereoTypeTargetAccess().getNameAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__StereoTypeTarget__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__StereoTypeTarget__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__StereoTypeTarget__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getStereoTypeTargetAccess().getGroup_1()); }
	(rule__StereoTypeTarget__Group_1__0)?
	{ after(grammarAccess.getStereoTypeTargetAccess().getGroup_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__StereoTypeTarget__Group_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__StereoTypeTarget__Group_1__0__Impl
	rule__StereoTypeTarget__Group_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__StereoTypeTarget__Group_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getStereoTypeTargetAccess().getWithKeyword_1_0()); }
	'with'
	{ after(grammarAccess.getStereoTypeTargetAccess().getWithKeyword_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__StereoTypeTarget__Group_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__StereoTypeTarget__Group_1__1__Impl
	rule__StereoTypeTarget__Group_1__2
;
finally {
	restoreStackSize(stackSize);
}

rule__StereoTypeTarget__Group_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getStereoTypeTargetAccess().getLeftCurlyBracketKeyword_1_1()); }
	'{'
	{ after(grammarAccess.getStereoTypeTargetAccess().getLeftCurlyBracketKeyword_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__StereoTypeTarget__Group_1__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__StereoTypeTarget__Group_1__2__Impl
	rule__StereoTypeTarget__Group_1__3
;
finally {
	restoreStackSize(stackSize);
}

rule__StereoTypeTarget__Group_1__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getStereoTypeTargetAccess().getAttributesAssignment_1_2()); }
	(rule__StereoTypeTarget__AttributesAssignment_1_2)
	{ after(grammarAccess.getStereoTypeTargetAccess().getAttributesAssignment_1_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__StereoTypeTarget__Group_1__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__StereoTypeTarget__Group_1__3__Impl
	rule__StereoTypeTarget__Group_1__4
;
finally {
	restoreStackSize(stackSize);
}

rule__StereoTypeTarget__Group_1__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getStereoTypeTargetAccess().getGroup_1_3()); }
	(rule__StereoTypeTarget__Group_1_3__0)*
	{ after(grammarAccess.getStereoTypeTargetAccess().getGroup_1_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__StereoTypeTarget__Group_1__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__StereoTypeTarget__Group_1__4__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__StereoTypeTarget__Group_1__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getStereoTypeTargetAccess().getRightCurlyBracketKeyword_1_4()); }
	'}'
	{ after(grammarAccess.getStereoTypeTargetAccess().getRightCurlyBracketKeyword_1_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__StereoTypeTarget__Group_1_3__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__StereoTypeTarget__Group_1_3__0__Impl
	rule__StereoTypeTarget__Group_1_3__1
;
finally {
	restoreStackSize(stackSize);
}

rule__StereoTypeTarget__Group_1_3__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getStereoTypeTargetAccess().getCommaKeyword_1_3_0()); }
	','
	{ after(grammarAccess.getStereoTypeTargetAccess().getCommaKeyword_1_3_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__StereoTypeTarget__Group_1_3__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__StereoTypeTarget__Group_1_3__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__StereoTypeTarget__Group_1_3__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getStereoTypeTargetAccess().getAttributesAssignment_1_3_1()); }
	(rule__StereoTypeTarget__AttributesAssignment_1_3_1)
	{ after(grammarAccess.getStereoTypeTargetAccess().getAttributesAssignment_1_3_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Attribute__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Attribute__Group__0__Impl
	rule__Attribute__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Attribute__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getAttributeAccess().getNameAssignment_0()); }
	(rule__Attribute__NameAssignment_0)
	{ after(grammarAccess.getAttributeAccess().getNameAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Attribute__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Attribute__Group__1__Impl
	rule__Attribute__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Attribute__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getAttributeAccess().getColonKeyword_1()); }
	':'
	{ after(grammarAccess.getAttributeAccess().getColonKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Attribute__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Attribute__Group__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Attribute__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getAttributeAccess().getValueAssignment_2()); }
	(rule__Attribute__ValueAssignment_2)
	{ after(grammarAccess.getAttributeAccess().getValueAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__QualifiedName__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__QualifiedName__Group__0__Impl
	rule__QualifiedName__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__QualifiedName__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_0()); }
	RULE_ID
	{ after(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__QualifiedName__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__QualifiedName__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__QualifiedName__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getQualifiedNameAccess().getGroup_1()); }
	(rule__QualifiedName__Group_1__0)*
	{ after(grammarAccess.getQualifiedNameAccess().getGroup_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__QualifiedName__Group_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__QualifiedName__Group_1__0__Impl
	rule__QualifiedName__Group_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__QualifiedName__Group_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getQualifiedNameAccess().getFullStopKeyword_1_0()); }
	'.'
	{ after(grammarAccess.getQualifiedNameAccess().getFullStopKeyword_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__QualifiedName__Group_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__QualifiedName__Group_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__QualifiedName__Group_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_1_1()); }
	RULE_ID
	{ after(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__CATEGORY__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__CATEGORY__Group__0__Impl
	rule__CATEGORY__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__CATEGORY__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getCATEGORYAccess().getIDTerminalRuleCall_0()); }
	RULE_ID
	{ after(grammarAccess.getCATEGORYAccess().getIDTerminalRuleCall_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__CATEGORY__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__CATEGORY__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__CATEGORY__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getCATEGORYAccess().getGroup_1()); }
	(rule__CATEGORY__Group_1__0)*
	{ after(grammarAccess.getCATEGORYAccess().getGroup_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__CATEGORY__Group_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__CATEGORY__Group_1__0__Impl
	rule__CATEGORY__Group_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__CATEGORY__Group_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getCATEGORYAccess().getSolidusKeyword_1_0()); }
	'/'
	{ after(grammarAccess.getCATEGORYAccess().getSolidusKeyword_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__CATEGORY__Group_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__CATEGORY__Group_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__CATEGORY__Group_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getCATEGORYAccess().getIDTerminalRuleCall_1_1()); }
	RULE_ID
	{ after(grammarAccess.getCATEGORYAccess().getIDTerminalRuleCall_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__InfoModelMappingModel__UnorderedGroup_7
	@init {
		int stackSize = keepStackSize();
		getUnorderedGroupHelper().enter(grammarAccess.getInfoModelMappingModelAccess().getUnorderedGroup_7());
	}
:
	rule__InfoModelMappingModel__UnorderedGroup_7__0
	?
;
finally {
	getUnorderedGroupHelper().leave(grammarAccess.getInfoModelMappingModelAccess().getUnorderedGroup_7());
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__UnorderedGroup_7__Impl
	@init {
		int stackSize = keepStackSize();
		boolean selected = false;
	}
:
		(
		( 
			{getUnorderedGroupHelper().canSelect(grammarAccess.getInfoModelMappingModelAccess().getUnorderedGroup_7(), 0)}?=>(
				{
					getUnorderedGroupHelper().select(grammarAccess.getInfoModelMappingModelAccess().getUnorderedGroup_7(), 0);
				}
				{
					selected = true;
				}
				(
					{ before(grammarAccess.getInfoModelMappingModelAccess().getGroup_7_0()); }
					(rule__InfoModelMappingModel__Group_7_0__0)
					{ after(grammarAccess.getInfoModelMappingModelAccess().getGroup_7_0()); }
				)
			)
		)|
		( 
			{getUnorderedGroupHelper().canSelect(grammarAccess.getInfoModelMappingModelAccess().getUnorderedGroup_7(), 1)}?=>(
				{
					getUnorderedGroupHelper().select(grammarAccess.getInfoModelMappingModelAccess().getUnorderedGroup_7(), 1);
				}
				{
					selected = true;
				}
				(
					{ before(grammarAccess.getInfoModelMappingModelAccess().getGroup_7_1()); }
					(rule__InfoModelMappingModel__Group_7_1__0)
					{ after(grammarAccess.getInfoModelMappingModelAccess().getGroup_7_1()); }
				)
			)
		)|
		( 
			{getUnorderedGroupHelper().canSelect(grammarAccess.getInfoModelMappingModelAccess().getUnorderedGroup_7(), 2)}?=>(
				{
					getUnorderedGroupHelper().select(grammarAccess.getInfoModelMappingModelAccess().getUnorderedGroup_7(), 2);
				}
				{
					selected = true;
				}
				(
					{ before(grammarAccess.getInfoModelMappingModelAccess().getGroup_7_2()); }
					(rule__InfoModelMappingModel__Group_7_2__0)
					{ after(grammarAccess.getInfoModelMappingModelAccess().getGroup_7_2()); }
				)
			)
		)
		)
;
finally {
	if (selected)
		getUnorderedGroupHelper().returnFromSelection(grammarAccess.getInfoModelMappingModelAccess().getUnorderedGroup_7());
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__UnorderedGroup_7__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__UnorderedGroup_7__Impl
	rule__InfoModelMappingModel__UnorderedGroup_7__1?
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__UnorderedGroup_7__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__UnorderedGroup_7__Impl
	rule__InfoModelMappingModel__UnorderedGroup_7__2?
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__UnorderedGroup_7__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InfoModelMappingModel__UnorderedGroup_7__Impl
;
finally {
	restoreStackSize(stackSize);
}


rule__FunctionBlockMappingModel__UnorderedGroup_7
	@init {
		int stackSize = keepStackSize();
		getUnorderedGroupHelper().enter(grammarAccess.getFunctionBlockMappingModelAccess().getUnorderedGroup_7());
	}
:
	rule__FunctionBlockMappingModel__UnorderedGroup_7__0
	?
;
finally {
	getUnorderedGroupHelper().leave(grammarAccess.getFunctionBlockMappingModelAccess().getUnorderedGroup_7());
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__UnorderedGroup_7__Impl
	@init {
		int stackSize = keepStackSize();
		boolean selected = false;
	}
:
		(
		( 
			{getUnorderedGroupHelper().canSelect(grammarAccess.getFunctionBlockMappingModelAccess().getUnorderedGroup_7(), 0)}?=>(
				{
					getUnorderedGroupHelper().select(grammarAccess.getFunctionBlockMappingModelAccess().getUnorderedGroup_7(), 0);
				}
				{
					selected = true;
				}
				(
					{ before(grammarAccess.getFunctionBlockMappingModelAccess().getGroup_7_0()); }
					(rule__FunctionBlockMappingModel__Group_7_0__0)
					{ after(grammarAccess.getFunctionBlockMappingModelAccess().getGroup_7_0()); }
				)
			)
		)|
		( 
			{getUnorderedGroupHelper().canSelect(grammarAccess.getFunctionBlockMappingModelAccess().getUnorderedGroup_7(), 1)}?=>(
				{
					getUnorderedGroupHelper().select(grammarAccess.getFunctionBlockMappingModelAccess().getUnorderedGroup_7(), 1);
				}
				{
					selected = true;
				}
				(
					{ before(grammarAccess.getFunctionBlockMappingModelAccess().getGroup_7_1()); }
					(rule__FunctionBlockMappingModel__Group_7_1__0)
					{ after(grammarAccess.getFunctionBlockMappingModelAccess().getGroup_7_1()); }
				)
			)
		)|
		( 
			{getUnorderedGroupHelper().canSelect(grammarAccess.getFunctionBlockMappingModelAccess().getUnorderedGroup_7(), 2)}?=>(
				{
					getUnorderedGroupHelper().select(grammarAccess.getFunctionBlockMappingModelAccess().getUnorderedGroup_7(), 2);
				}
				{
					selected = true;
				}
				(
					{ before(grammarAccess.getFunctionBlockMappingModelAccess().getGroup_7_2()); }
					(rule__FunctionBlockMappingModel__Group_7_2__0)
					{ after(grammarAccess.getFunctionBlockMappingModelAccess().getGroup_7_2()); }
				)
			)
		)
		)
;
finally {
	if (selected)
		getUnorderedGroupHelper().returnFromSelection(grammarAccess.getFunctionBlockMappingModelAccess().getUnorderedGroup_7());
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__UnorderedGroup_7__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__UnorderedGroup_7__Impl
	rule__FunctionBlockMappingModel__UnorderedGroup_7__1?
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__UnorderedGroup_7__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__UnorderedGroup_7__Impl
	rule__FunctionBlockMappingModel__UnorderedGroup_7__2?
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__UnorderedGroup_7__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionBlockMappingModel__UnorderedGroup_7__Impl
;
finally {
	restoreStackSize(stackSize);
}


rule__EntityMappingModel__UnorderedGroup_7
	@init {
		int stackSize = keepStackSize();
		getUnorderedGroupHelper().enter(grammarAccess.getEntityMappingModelAccess().getUnorderedGroup_7());
	}
:
	rule__EntityMappingModel__UnorderedGroup_7__0
	?
;
finally {
	getUnorderedGroupHelper().leave(grammarAccess.getEntityMappingModelAccess().getUnorderedGroup_7());
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__UnorderedGroup_7__Impl
	@init {
		int stackSize = keepStackSize();
		boolean selected = false;
	}
:
		(
		( 
			{getUnorderedGroupHelper().canSelect(grammarAccess.getEntityMappingModelAccess().getUnorderedGroup_7(), 0)}?=>(
				{
					getUnorderedGroupHelper().select(grammarAccess.getEntityMappingModelAccess().getUnorderedGroup_7(), 0);
				}
				{
					selected = true;
				}
				(
					{ before(grammarAccess.getEntityMappingModelAccess().getGroup_7_0()); }
					(rule__EntityMappingModel__Group_7_0__0)
					{ after(grammarAccess.getEntityMappingModelAccess().getGroup_7_0()); }
				)
			)
		)|
		( 
			{getUnorderedGroupHelper().canSelect(grammarAccess.getEntityMappingModelAccess().getUnorderedGroup_7(), 1)}?=>(
				{
					getUnorderedGroupHelper().select(grammarAccess.getEntityMappingModelAccess().getUnorderedGroup_7(), 1);
				}
				{
					selected = true;
				}
				(
					{ before(grammarAccess.getEntityMappingModelAccess().getGroup_7_1()); }
					(rule__EntityMappingModel__Group_7_1__0)
					{ after(grammarAccess.getEntityMappingModelAccess().getGroup_7_1()); }
				)
			)
		)|
		( 
			{getUnorderedGroupHelper().canSelect(grammarAccess.getEntityMappingModelAccess().getUnorderedGroup_7(), 2)}?=>(
				{
					getUnorderedGroupHelper().select(grammarAccess.getEntityMappingModelAccess().getUnorderedGroup_7(), 2);
				}
				{
					selected = true;
				}
				(
					{ before(grammarAccess.getEntityMappingModelAccess().getGroup_7_2()); }
					(rule__EntityMappingModel__Group_7_2__0)
					{ after(grammarAccess.getEntityMappingModelAccess().getGroup_7_2()); }
				)
			)
		)
		)
;
finally {
	if (selected)
		getUnorderedGroupHelper().returnFromSelection(grammarAccess.getEntityMappingModelAccess().getUnorderedGroup_7());
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__UnorderedGroup_7__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__UnorderedGroup_7__Impl
	rule__EntityMappingModel__UnorderedGroup_7__1?
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__UnorderedGroup_7__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__UnorderedGroup_7__Impl
	rule__EntityMappingModel__UnorderedGroup_7__2?
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__UnorderedGroup_7__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EntityMappingModel__UnorderedGroup_7__Impl
;
finally {
	restoreStackSize(stackSize);
}


rule__EnumMappingModel__UnorderedGroup_7
	@init {
		int stackSize = keepStackSize();
		getUnorderedGroupHelper().enter(grammarAccess.getEnumMappingModelAccess().getUnorderedGroup_7());
	}
:
	rule__EnumMappingModel__UnorderedGroup_7__0
	?
;
finally {
	getUnorderedGroupHelper().leave(grammarAccess.getEnumMappingModelAccess().getUnorderedGroup_7());
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__UnorderedGroup_7__Impl
	@init {
		int stackSize = keepStackSize();
		boolean selected = false;
	}
:
		(
		( 
			{getUnorderedGroupHelper().canSelect(grammarAccess.getEnumMappingModelAccess().getUnorderedGroup_7(), 0)}?=>(
				{
					getUnorderedGroupHelper().select(grammarAccess.getEnumMappingModelAccess().getUnorderedGroup_7(), 0);
				}
				{
					selected = true;
				}
				(
					{ before(grammarAccess.getEnumMappingModelAccess().getGroup_7_0()); }
					(rule__EnumMappingModel__Group_7_0__0)
					{ after(grammarAccess.getEnumMappingModelAccess().getGroup_7_0()); }
				)
			)
		)|
		( 
			{getUnorderedGroupHelper().canSelect(grammarAccess.getEnumMappingModelAccess().getUnorderedGroup_7(), 1)}?=>(
				{
					getUnorderedGroupHelper().select(grammarAccess.getEnumMappingModelAccess().getUnorderedGroup_7(), 1);
				}
				{
					selected = true;
				}
				(
					{ before(grammarAccess.getEnumMappingModelAccess().getGroup_7_1()); }
					(rule__EnumMappingModel__Group_7_1__0)
					{ after(grammarAccess.getEnumMappingModelAccess().getGroup_7_1()); }
				)
			)
		)|
		( 
			{getUnorderedGroupHelper().canSelect(grammarAccess.getEnumMappingModelAccess().getUnorderedGroup_7(), 2)}?=>(
				{
					getUnorderedGroupHelper().select(grammarAccess.getEnumMappingModelAccess().getUnorderedGroup_7(), 2);
				}
				{
					selected = true;
				}
				(
					{ before(grammarAccess.getEnumMappingModelAccess().getGroup_7_2()); }
					(rule__EnumMappingModel__Group_7_2__0)
					{ after(grammarAccess.getEnumMappingModelAccess().getGroup_7_2()); }
				)
			)
		)
		)
;
finally {
	if (selected)
		getUnorderedGroupHelper().returnFromSelection(grammarAccess.getEnumMappingModelAccess().getUnorderedGroup_7());
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__UnorderedGroup_7__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__UnorderedGroup_7__Impl
	rule__EnumMappingModel__UnorderedGroup_7__1?
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__UnorderedGroup_7__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__UnorderedGroup_7__Impl
	rule__EnumMappingModel__UnorderedGroup_7__2?
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__UnorderedGroup_7__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EnumMappingModel__UnorderedGroup_7__Impl
;
finally {
	restoreStackSize(stackSize);
}


rule__InfoModelMappingModel__LangAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInfoModelMappingModelAccess().getLangVortoLangVersionEnumRuleCall_2_0()); }
		ruleVortoLangVersion
		{ after(grammarAccess.getInfoModelMappingModelAccess().getLangVortoLangVersionEnumRuleCall_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__NamespaceAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInfoModelMappingModelAccess().getNamespaceQualifiedNameParserRuleCall_4_0()); }
		ruleQualifiedName
		{ after(grammarAccess.getInfoModelMappingModelAccess().getNamespaceQualifiedNameParserRuleCall_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__VersionAssignment_6
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInfoModelMappingModelAccess().getVersionVERSIONTerminalRuleCall_6_0()); }
		RULE_VERSION
		{ after(grammarAccess.getInfoModelMappingModelAccess().getVersionVERSIONTerminalRuleCall_6_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__DisplaynameAssignment_7_0_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInfoModelMappingModelAccess().getDisplaynameSTRINGTerminalRuleCall_7_0_1_0()); }
		RULE_STRING
		{ after(grammarAccess.getInfoModelMappingModelAccess().getDisplaynameSTRINGTerminalRuleCall_7_0_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__DescriptionAssignment_7_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInfoModelMappingModelAccess().getDescriptionSTRINGTerminalRuleCall_7_1_1_0()); }
		RULE_STRING
		{ after(grammarAccess.getInfoModelMappingModelAccess().getDescriptionSTRINGTerminalRuleCall_7_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__CategoryAssignment_7_2_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInfoModelMappingModelAccess().getCategoryCATEGORYParserRuleCall_7_2_1_0()); }
		ruleCATEGORY
		{ after(grammarAccess.getInfoModelMappingModelAccess().getCategoryCATEGORYParserRuleCall_7_2_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__ReferencesAssignment_8
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInfoModelMappingModelAccess().getReferencesModelReferenceParserRuleCall_8_0()); }
		ruleModelReference
		{ after(grammarAccess.getInfoModelMappingModelAccess().getReferencesModelReferenceParserRuleCall_8_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__NameAssignment_10
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInfoModelMappingModelAccess().getNameIDTerminalRuleCall_10_0()); }
		RULE_ID
		{ after(grammarAccess.getInfoModelMappingModelAccess().getNameIDTerminalRuleCall_10_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__TargetPlatformAssignment_13
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInfoModelMappingModelAccess().getTargetPlatformIDTerminalRuleCall_13_0()); }
		RULE_ID
		{ after(grammarAccess.getInfoModelMappingModelAccess().getTargetPlatformIDTerminalRuleCall_13_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingModel__RulesAssignment_14
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInfoModelMappingModelAccess().getRulesInfoModelMappingRuleParserRuleCall_14_0()); }
		ruleInfoModelMappingRule
		{ after(grammarAccess.getInfoModelMappingModelAccess().getRulesInfoModelMappingRuleParserRuleCall_14_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingRule__SourcesAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInfoModelMappingRuleAccess().getSourcesInfomodelSourceParserRuleCall_1_0()); }
		ruleInfomodelSource
		{ after(grammarAccess.getInfoModelMappingRuleAccess().getSourcesInfomodelSourceParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingRule__SourcesAssignment_2_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInfoModelMappingRuleAccess().getSourcesInfomodelSourceParserRuleCall_2_1_0()); }
		ruleInfomodelSource
		{ after(grammarAccess.getInfoModelMappingRuleAccess().getSourcesInfomodelSourceParserRuleCall_2_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelMappingRule__TargetAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInfoModelMappingRuleAccess().getTargetTargetParserRuleCall_4_0()); }
		ruleTarget
		{ after(grammarAccess.getInfoModelMappingRuleAccess().getTargetTargetParserRuleCall_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelPropertySource__ModelAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInfoModelPropertySourceAccess().getModelInformationModelCrossReference_0_0()); }
		(
			{ before(grammarAccess.getInfoModelPropertySourceAccess().getModelInformationModelIDTerminalRuleCall_0_0_1()); }
			RULE_ID
			{ after(grammarAccess.getInfoModelPropertySourceAccess().getModelInformationModelIDTerminalRuleCall_0_0_1()); }
		)
		{ after(grammarAccess.getInfoModelPropertySourceAccess().getModelInformationModelCrossReference_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelPropertySource__PropertyAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInfoModelPropertySourceAccess().getPropertyFunctionblockPropertyCrossReference_4_0()); }
		(
			{ before(grammarAccess.getInfoModelPropertySourceAccess().getPropertyFunctionblockPropertyIDTerminalRuleCall_4_0_1()); }
			RULE_ID
			{ after(grammarAccess.getInfoModelPropertySourceAccess().getPropertyFunctionblockPropertyIDTerminalRuleCall_4_0_1()); }
		)
		{ after(grammarAccess.getInfoModelPropertySourceAccess().getPropertyFunctionblockPropertyCrossReference_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelAttributeSource__ModelAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInfoModelAttributeSourceAccess().getModelInformationModelCrossReference_0_0()); }
		(
			{ before(grammarAccess.getInfoModelAttributeSourceAccess().getModelInformationModelIDTerminalRuleCall_0_0_1()); }
			RULE_ID
			{ after(grammarAccess.getInfoModelAttributeSourceAccess().getModelInformationModelIDTerminalRuleCall_0_0_1()); }
		)
		{ after(grammarAccess.getInfoModelAttributeSourceAccess().getModelInformationModelCrossReference_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InfoModelAttributeSource__AttributeAssignment_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInfoModelAttributeSourceAccess().getAttributeModelAttributeEnumRuleCall_1_1_0()); }
		ruleModelAttribute
		{ after(grammarAccess.getInfoModelAttributeSourceAccess().getAttributeModelAttributeEnumRuleCall_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__LangAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFunctionBlockMappingModelAccess().getLangVortoLangVersionEnumRuleCall_2_0()); }
		ruleVortoLangVersion
		{ after(grammarAccess.getFunctionBlockMappingModelAccess().getLangVortoLangVersionEnumRuleCall_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__NamespaceAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFunctionBlockMappingModelAccess().getNamespaceQualifiedNameParserRuleCall_4_0()); }
		ruleQualifiedName
		{ after(grammarAccess.getFunctionBlockMappingModelAccess().getNamespaceQualifiedNameParserRuleCall_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__VersionAssignment_6
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFunctionBlockMappingModelAccess().getVersionVERSIONTerminalRuleCall_6_0()); }
		RULE_VERSION
		{ after(grammarAccess.getFunctionBlockMappingModelAccess().getVersionVERSIONTerminalRuleCall_6_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__DisplaynameAssignment_7_0_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFunctionBlockMappingModelAccess().getDisplaynameSTRINGTerminalRuleCall_7_0_1_0()); }
		RULE_STRING
		{ after(grammarAccess.getFunctionBlockMappingModelAccess().getDisplaynameSTRINGTerminalRuleCall_7_0_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__DescriptionAssignment_7_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFunctionBlockMappingModelAccess().getDescriptionSTRINGTerminalRuleCall_7_1_1_0()); }
		RULE_STRING
		{ after(grammarAccess.getFunctionBlockMappingModelAccess().getDescriptionSTRINGTerminalRuleCall_7_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__CategoryAssignment_7_2_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFunctionBlockMappingModelAccess().getCategoryCATEGORYParserRuleCall_7_2_1_0()); }
		ruleCATEGORY
		{ after(grammarAccess.getFunctionBlockMappingModelAccess().getCategoryCATEGORYParserRuleCall_7_2_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__ReferencesAssignment_8
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFunctionBlockMappingModelAccess().getReferencesModelReferenceParserRuleCall_8_0()); }
		ruleModelReference
		{ after(grammarAccess.getFunctionBlockMappingModelAccess().getReferencesModelReferenceParserRuleCall_8_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__NameAssignment_10
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFunctionBlockMappingModelAccess().getNameIDTerminalRuleCall_10_0()); }
		RULE_ID
		{ after(grammarAccess.getFunctionBlockMappingModelAccess().getNameIDTerminalRuleCall_10_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__TargetPlatformAssignment_13
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFunctionBlockMappingModelAccess().getTargetPlatformIDTerminalRuleCall_13_0()); }
		RULE_ID
		{ after(grammarAccess.getFunctionBlockMappingModelAccess().getTargetPlatformIDTerminalRuleCall_13_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingModel__RulesAssignment_14
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFunctionBlockMappingModelAccess().getRulesFunctionBlockMappingRuleParserRuleCall_14_0()); }
		ruleFunctionBlockMappingRule
		{ after(grammarAccess.getFunctionBlockMappingModelAccess().getRulesFunctionBlockMappingRuleParserRuleCall_14_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__ImportedNamespaceAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getModelReferenceAccess().getImportedNamespaceQualifiedNameParserRuleCall_1_0()); }
		ruleQualifiedName
		{ after(grammarAccess.getModelReferenceAccess().getImportedNamespaceQualifiedNameParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__VersionAssignment_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getModelReferenceAccess().getVersionVERSIONTerminalRuleCall_3_0()); }
		RULE_VERSION
		{ after(grammarAccess.getModelReferenceAccess().getVersionVERSIONTerminalRuleCall_3_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingRule__SourcesAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFunctionBlockMappingRuleAccess().getSourcesFunctionBlockSourceParserRuleCall_1_0()); }
		ruleFunctionBlockSource
		{ after(grammarAccess.getFunctionBlockMappingRuleAccess().getSourcesFunctionBlockSourceParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingRule__SourcesAssignment_2_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFunctionBlockMappingRuleAccess().getSourcesFunctionBlockSourceParserRuleCall_2_1_0()); }
		ruleFunctionBlockSource
		{ after(grammarAccess.getFunctionBlockMappingRuleAccess().getSourcesFunctionBlockSourceParserRuleCall_2_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockMappingRule__TargetAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFunctionBlockMappingRuleAccess().getTargetTargetParserRuleCall_4_0()); }
		ruleTarget
		{ after(grammarAccess.getFunctionBlockMappingRuleAccess().getTargetTargetParserRuleCall_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockAttributeSource__ModelAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFunctionBlockAttributeSourceAccess().getModelFunctionblockModelCrossReference_0_0()); }
		(
			{ before(grammarAccess.getFunctionBlockAttributeSourceAccess().getModelFunctionblockModelIDTerminalRuleCall_0_0_1()); }
			RULE_ID
			{ after(grammarAccess.getFunctionBlockAttributeSourceAccess().getModelFunctionblockModelIDTerminalRuleCall_0_0_1()); }
		)
		{ after(grammarAccess.getFunctionBlockAttributeSourceAccess().getModelFunctionblockModelCrossReference_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionBlockAttributeSource__AttributeAssignment_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFunctionBlockAttributeSourceAccess().getAttributeModelAttributeEnumRuleCall_1_1_0()); }
		ruleModelAttribute
		{ after(grammarAccess.getFunctionBlockAttributeSourceAccess().getAttributeModelAttributeEnumRuleCall_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ConfigurationSource__ModelAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getConfigurationSourceAccess().getModelFunctionblockModelCrossReference_0_0()); }
		(
			{ before(grammarAccess.getConfigurationSourceAccess().getModelFunctionblockModelIDTerminalRuleCall_0_0_1()); }
			RULE_ID
			{ after(grammarAccess.getConfigurationSourceAccess().getModelFunctionblockModelIDTerminalRuleCall_0_0_1()); }
		)
		{ after(grammarAccess.getConfigurationSourceAccess().getModelFunctionblockModelCrossReference_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ConfigurationSource__PropertyAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getConfigurationSourceAccess().getPropertyPropertyCrossReference_4_0()); }
		(
			{ before(grammarAccess.getConfigurationSourceAccess().getPropertyPropertyIDTerminalRuleCall_4_0_1()); }
			RULE_ID
			{ after(grammarAccess.getConfigurationSourceAccess().getPropertyPropertyIDTerminalRuleCall_4_0_1()); }
		)
		{ after(grammarAccess.getConfigurationSourceAccess().getPropertyPropertyCrossReference_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__StatusSource__ModelAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getStatusSourceAccess().getModelFunctionblockModelCrossReference_0_0()); }
		(
			{ before(grammarAccess.getStatusSourceAccess().getModelFunctionblockModelIDTerminalRuleCall_0_0_1()); }
			RULE_ID
			{ after(grammarAccess.getStatusSourceAccess().getModelFunctionblockModelIDTerminalRuleCall_0_0_1()); }
		)
		{ after(grammarAccess.getStatusSourceAccess().getModelFunctionblockModelCrossReference_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__StatusSource__PropertyAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getStatusSourceAccess().getPropertyPropertyCrossReference_4_0()); }
		(
			{ before(grammarAccess.getStatusSourceAccess().getPropertyPropertyIDTerminalRuleCall_4_0_1()); }
			RULE_ID
			{ after(grammarAccess.getStatusSourceAccess().getPropertyPropertyIDTerminalRuleCall_4_0_1()); }
		)
		{ after(grammarAccess.getStatusSourceAccess().getPropertyPropertyCrossReference_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FaultSource__ModelAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFaultSourceAccess().getModelFunctionblockModelCrossReference_0_0()); }
		(
			{ before(grammarAccess.getFaultSourceAccess().getModelFunctionblockModelIDTerminalRuleCall_0_0_1()); }
			RULE_ID
			{ after(grammarAccess.getFaultSourceAccess().getModelFunctionblockModelIDTerminalRuleCall_0_0_1()); }
		)
		{ after(grammarAccess.getFaultSourceAccess().getModelFunctionblockModelCrossReference_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FaultSource__PropertyAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFaultSourceAccess().getPropertyPropertyCrossReference_4_0()); }
		(
			{ before(grammarAccess.getFaultSourceAccess().getPropertyPropertyIDTerminalRuleCall_4_0_1()); }
			RULE_ID
			{ after(grammarAccess.getFaultSourceAccess().getPropertyPropertyIDTerminalRuleCall_4_0_1()); }
		)
		{ after(grammarAccess.getFaultSourceAccess().getPropertyPropertyCrossReference_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__OperationSource__ModelAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getOperationSourceAccess().getModelFunctionblockModelCrossReference_0_0()); }
		(
			{ before(grammarAccess.getOperationSourceAccess().getModelFunctionblockModelIDTerminalRuleCall_0_0_1()); }
			RULE_ID
			{ after(grammarAccess.getOperationSourceAccess().getModelFunctionblockModelIDTerminalRuleCall_0_0_1()); }
		)
		{ after(grammarAccess.getOperationSourceAccess().getModelFunctionblockModelCrossReference_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__OperationSource__OperationAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getOperationSourceAccess().getOperationOperationCrossReference_4_0()); }
		(
			{ before(grammarAccess.getOperationSourceAccess().getOperationOperationIDTerminalRuleCall_4_0_1()); }
			RULE_ID
			{ after(grammarAccess.getOperationSourceAccess().getOperationOperationIDTerminalRuleCall_4_0_1()); }
		)
		{ after(grammarAccess.getOperationSourceAccess().getOperationOperationCrossReference_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__OperationSource__ParamAssignment_5_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getOperationSourceAccess().getParamParamCrossReference_5_3_0()); }
		(
			{ before(grammarAccess.getOperationSourceAccess().getParamParamIDTerminalRuleCall_5_3_0_1()); }
			RULE_ID
			{ after(grammarAccess.getOperationSourceAccess().getParamParamIDTerminalRuleCall_5_3_0_1()); }
		)
		{ after(grammarAccess.getOperationSourceAccess().getParamParamCrossReference_5_3_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EventSource__ModelAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEventSourceAccess().getModelFunctionblockModelCrossReference_0_0()); }
		(
			{ before(grammarAccess.getEventSourceAccess().getModelFunctionblockModelIDTerminalRuleCall_0_0_1()); }
			RULE_ID
			{ after(grammarAccess.getEventSourceAccess().getModelFunctionblockModelIDTerminalRuleCall_0_0_1()); }
		)
		{ after(grammarAccess.getEventSourceAccess().getModelFunctionblockModelCrossReference_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EventSource__EventAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEventSourceAccess().getEventEventCrossReference_4_0()); }
		(
			{ before(grammarAccess.getEventSourceAccess().getEventEventIDTerminalRuleCall_4_0_1()); }
			RULE_ID
			{ after(grammarAccess.getEventSourceAccess().getEventEventIDTerminalRuleCall_4_0_1()); }
		)
		{ after(grammarAccess.getEventSourceAccess().getEventEventCrossReference_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EventSource__EventPropertyAssignment_5_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEventSourceAccess().getEventPropertyPropertyCrossReference_5_1_0()); }
		(
			{ before(grammarAccess.getEventSourceAccess().getEventPropertyPropertyIDTerminalRuleCall_5_1_0_1()); }
			RULE_ID
			{ after(grammarAccess.getEventSourceAccess().getEventPropertyPropertyIDTerminalRuleCall_5_1_0_1()); }
		)
		{ after(grammarAccess.getEventSourceAccess().getEventPropertyPropertyCrossReference_5_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__LangAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityMappingModelAccess().getLangVortoLangVersionEnumRuleCall_2_0()); }
		ruleVortoLangVersion
		{ after(grammarAccess.getEntityMappingModelAccess().getLangVortoLangVersionEnumRuleCall_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__NamespaceAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityMappingModelAccess().getNamespaceQualifiedNameParserRuleCall_4_0()); }
		ruleQualifiedName
		{ after(grammarAccess.getEntityMappingModelAccess().getNamespaceQualifiedNameParserRuleCall_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__VersionAssignment_6
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityMappingModelAccess().getVersionVERSIONTerminalRuleCall_6_0()); }
		RULE_VERSION
		{ after(grammarAccess.getEntityMappingModelAccess().getVersionVERSIONTerminalRuleCall_6_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__DisplaynameAssignment_7_0_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityMappingModelAccess().getDisplaynameSTRINGTerminalRuleCall_7_0_1_0()); }
		RULE_STRING
		{ after(grammarAccess.getEntityMappingModelAccess().getDisplaynameSTRINGTerminalRuleCall_7_0_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__DescriptionAssignment_7_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityMappingModelAccess().getDescriptionSTRINGTerminalRuleCall_7_1_1_0()); }
		RULE_STRING
		{ after(grammarAccess.getEntityMappingModelAccess().getDescriptionSTRINGTerminalRuleCall_7_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__CategoryAssignment_7_2_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityMappingModelAccess().getCategoryCATEGORYParserRuleCall_7_2_1_0()); }
		ruleCATEGORY
		{ after(grammarAccess.getEntityMappingModelAccess().getCategoryCATEGORYParserRuleCall_7_2_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__ReferencesAssignment_8
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityMappingModelAccess().getReferencesModelReferenceParserRuleCall_8_0()); }
		ruleModelReference
		{ after(grammarAccess.getEntityMappingModelAccess().getReferencesModelReferenceParserRuleCall_8_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__NameAssignment_10
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityMappingModelAccess().getNameIDTerminalRuleCall_10_0()); }
		RULE_ID
		{ after(grammarAccess.getEntityMappingModelAccess().getNameIDTerminalRuleCall_10_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__TargetPlatformAssignment_13
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityMappingModelAccess().getTargetPlatformIDTerminalRuleCall_13_0()); }
		RULE_ID
		{ after(grammarAccess.getEntityMappingModelAccess().getTargetPlatformIDTerminalRuleCall_13_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingModel__RulesAssignment_14
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityMappingModelAccess().getRulesEntityMappingRuleParserRuleCall_14_0()); }
		ruleEntityMappingRule
		{ after(grammarAccess.getEntityMappingModelAccess().getRulesEntityMappingRuleParserRuleCall_14_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingRule__SourcesAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityMappingRuleAccess().getSourcesEntitySourceParserRuleCall_1_0()); }
		ruleEntitySource
		{ after(grammarAccess.getEntityMappingRuleAccess().getSourcesEntitySourceParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingRule__SourcesAssignment_2_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityMappingRuleAccess().getSourcesEntitySourceParserRuleCall_2_1_0()); }
		ruleEntitySource
		{ after(grammarAccess.getEntityMappingRuleAccess().getSourcesEntitySourceParserRuleCall_2_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityMappingRule__TargetAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityMappingRuleAccess().getTargetTargetParserRuleCall_4_0()); }
		ruleTarget
		{ after(grammarAccess.getEntityMappingRuleAccess().getTargetTargetParserRuleCall_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityPropertySource__ModelAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityPropertySourceAccess().getModelEntityCrossReference_0_0()); }
		(
			{ before(grammarAccess.getEntityPropertySourceAccess().getModelEntityIDTerminalRuleCall_0_0_1()); }
			RULE_ID
			{ after(grammarAccess.getEntityPropertySourceAccess().getModelEntityIDTerminalRuleCall_0_0_1()); }
		)
		{ after(grammarAccess.getEntityPropertySourceAccess().getModelEntityCrossReference_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityPropertySource__PropertyAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityPropertySourceAccess().getPropertyPropertyCrossReference_2_0()); }
		(
			{ before(grammarAccess.getEntityPropertySourceAccess().getPropertyPropertyIDTerminalRuleCall_2_0_1()); }
			RULE_ID
			{ after(grammarAccess.getEntityPropertySourceAccess().getPropertyPropertyIDTerminalRuleCall_2_0_1()); }
		)
		{ after(grammarAccess.getEntityPropertySourceAccess().getPropertyPropertyCrossReference_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityAttributeSource__ModelAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityAttributeSourceAccess().getModelEntityCrossReference_0_0()); }
		(
			{ before(grammarAccess.getEntityAttributeSourceAccess().getModelEntityIDTerminalRuleCall_0_0_1()); }
			RULE_ID
			{ after(grammarAccess.getEntityAttributeSourceAccess().getModelEntityIDTerminalRuleCall_0_0_1()); }
		)
		{ after(grammarAccess.getEntityAttributeSourceAccess().getModelEntityCrossReference_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EntityAttributeSource__AttributeAssignment_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEntityAttributeSourceAccess().getAttributeModelAttributeEnumRuleCall_1_1_0()); }
		ruleModelAttribute
		{ after(grammarAccess.getEntityAttributeSourceAccess().getAttributeModelAttributeEnumRuleCall_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__LangAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumMappingModelAccess().getLangVortoLangVersionEnumRuleCall_2_0()); }
		ruleVortoLangVersion
		{ after(grammarAccess.getEnumMappingModelAccess().getLangVortoLangVersionEnumRuleCall_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__NamespaceAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumMappingModelAccess().getNamespaceQualifiedNameParserRuleCall_4_0()); }
		ruleQualifiedName
		{ after(grammarAccess.getEnumMappingModelAccess().getNamespaceQualifiedNameParserRuleCall_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__VersionAssignment_6
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumMappingModelAccess().getVersionVERSIONTerminalRuleCall_6_0()); }
		RULE_VERSION
		{ after(grammarAccess.getEnumMappingModelAccess().getVersionVERSIONTerminalRuleCall_6_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__DisplaynameAssignment_7_0_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumMappingModelAccess().getDisplaynameSTRINGTerminalRuleCall_7_0_1_0()); }
		RULE_STRING
		{ after(grammarAccess.getEnumMappingModelAccess().getDisplaynameSTRINGTerminalRuleCall_7_0_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__DescriptionAssignment_7_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumMappingModelAccess().getDescriptionSTRINGTerminalRuleCall_7_1_1_0()); }
		RULE_STRING
		{ after(grammarAccess.getEnumMappingModelAccess().getDescriptionSTRINGTerminalRuleCall_7_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__CategoryAssignment_7_2_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumMappingModelAccess().getCategoryCATEGORYParserRuleCall_7_2_1_0()); }
		ruleCATEGORY
		{ after(grammarAccess.getEnumMappingModelAccess().getCategoryCATEGORYParserRuleCall_7_2_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__ReferencesAssignment_8
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumMappingModelAccess().getReferencesModelReferenceParserRuleCall_8_0()); }
		ruleModelReference
		{ after(grammarAccess.getEnumMappingModelAccess().getReferencesModelReferenceParserRuleCall_8_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__NameAssignment_10
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumMappingModelAccess().getNameIDTerminalRuleCall_10_0()); }
		RULE_ID
		{ after(grammarAccess.getEnumMappingModelAccess().getNameIDTerminalRuleCall_10_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__TargetPlatformAssignment_13
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumMappingModelAccess().getTargetPlatformIDTerminalRuleCall_13_0()); }
		RULE_ID
		{ after(grammarAccess.getEnumMappingModelAccess().getTargetPlatformIDTerminalRuleCall_13_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingModel__RulesAssignment_14
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumMappingModelAccess().getRulesEnumMappingRuleParserRuleCall_14_0()); }
		ruleEnumMappingRule
		{ after(grammarAccess.getEnumMappingModelAccess().getRulesEnumMappingRuleParserRuleCall_14_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingRule__SourcesAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumMappingRuleAccess().getSourcesEnumSourceParserRuleCall_1_0()); }
		ruleEnumSource
		{ after(grammarAccess.getEnumMappingRuleAccess().getSourcesEnumSourceParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingRule__SourcesAssignment_2_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumMappingRuleAccess().getSourcesEnumSourceParserRuleCall_2_1_0()); }
		ruleEnumSource
		{ after(grammarAccess.getEnumMappingRuleAccess().getSourcesEnumSourceParserRuleCall_2_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumMappingRule__TargetAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumMappingRuleAccess().getTargetTargetParserRuleCall_4_0()); }
		ruleTarget
		{ after(grammarAccess.getEnumMappingRuleAccess().getTargetTargetParserRuleCall_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumPropertySource__ModelAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumPropertySourceAccess().getModelEnumCrossReference_0_0()); }
		(
			{ before(grammarAccess.getEnumPropertySourceAccess().getModelEnumIDTerminalRuleCall_0_0_1()); }
			RULE_ID
			{ after(grammarAccess.getEnumPropertySourceAccess().getModelEnumIDTerminalRuleCall_0_0_1()); }
		)
		{ after(grammarAccess.getEnumPropertySourceAccess().getModelEnumCrossReference_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumPropertySource__PropertyAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumPropertySourceAccess().getPropertyEnumLiteralCrossReference_2_0()); }
		(
			{ before(grammarAccess.getEnumPropertySourceAccess().getPropertyEnumLiteralIDTerminalRuleCall_2_0_1()); }
			RULE_ID
			{ after(grammarAccess.getEnumPropertySourceAccess().getPropertyEnumLiteralIDTerminalRuleCall_2_0_1()); }
		)
		{ after(grammarAccess.getEnumPropertySourceAccess().getPropertyEnumLiteralCrossReference_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumAttributeSource__ModelAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumAttributeSourceAccess().getModelEnumCrossReference_0_0()); }
		(
			{ before(grammarAccess.getEnumAttributeSourceAccess().getModelEnumIDTerminalRuleCall_0_0_1()); }
			RULE_ID
			{ after(grammarAccess.getEnumAttributeSourceAccess().getModelEnumIDTerminalRuleCall_0_0_1()); }
		)
		{ after(grammarAccess.getEnumAttributeSourceAccess().getModelEnumCrossReference_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EnumAttributeSource__AttributeAssignment_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEnumAttributeSourceAccess().getAttributeModelAttributeEnumRuleCall_1_1_0()); }
		ruleModelAttribute
		{ after(grammarAccess.getEnumAttributeSourceAccess().getAttributeModelAttributeEnumRuleCall_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ReferenceTarget__MappingModelAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getReferenceTargetAccess().getMappingModelMappingModelCrossReference_1_0()); }
		(
			{ before(grammarAccess.getReferenceTargetAccess().getMappingModelMappingModelIDTerminalRuleCall_1_0_1()); }
			RULE_ID
			{ after(grammarAccess.getReferenceTargetAccess().getMappingModelMappingModelIDTerminalRuleCall_1_0_1()); }
		)
		{ after(grammarAccess.getReferenceTargetAccess().getMappingModelMappingModelCrossReference_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__StereoTypeTarget__NameAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getStereoTypeTargetAccess().getNameIDTerminalRuleCall_0_0()); }
		RULE_ID
		{ after(grammarAccess.getStereoTypeTargetAccess().getNameIDTerminalRuleCall_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__StereoTypeTarget__AttributesAssignment_1_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getStereoTypeTargetAccess().getAttributesAttributeParserRuleCall_1_2_0()); }
		ruleAttribute
		{ after(grammarAccess.getStereoTypeTargetAccess().getAttributesAttributeParserRuleCall_1_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__StereoTypeTarget__AttributesAssignment_1_3_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getStereoTypeTargetAccess().getAttributesAttributeParserRuleCall_1_3_1_0()); }
		ruleAttribute
		{ after(grammarAccess.getStereoTypeTargetAccess().getAttributesAttributeParserRuleCall_1_3_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Attribute__NameAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getAttributeAccess().getNameIDTerminalRuleCall_0_0()); }
		RULE_ID
		{ after(grammarAccess.getAttributeAccess().getNameIDTerminalRuleCall_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Attribute__ValueAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getAttributeAccess().getValueSTRINGTerminalRuleCall_2_0()); }
		RULE_STRING
		{ after(grammarAccess.getAttributeAccess().getValueSTRINGTerminalRuleCall_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

RULE_VERSION : ('0'..'9')* '.' ('0'..'9')* '.' ('0'..'9')* ('-' RULE_ID)?;

RULE_ID : '^'? ('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*;

RULE_INT : ('0'..'9')+;

RULE_STRING : ('"' ('\\' .|~(('\\'|'"')))* '"'|'\'' ('\\' .|~(('\\'|'\'')))* '\'');

RULE_ML_COMMENT : '/*' ( options {greedy=false;} : . )*'*/';

RULE_SL_COMMENT : '//' ~(('\n'|'\r'))* ('\r'? '\n')?;

RULE_WS : (' '|'\t'|'\r'|'\n')+;

RULE_ANY_OTHER : .;
